# Copyright (c) 2004-5 Marek Hnilica. All rights reserved.
# Provides TagTestDiag used when getting tags from filename
# Distributed under GPL version 2, or (at your option) later

import wx
from wx.lib.mixins.listctrl import ListCtrlAutoWidthMixin
import os

class TagTestDiag(wx.Dialog):
	def __init__(self,parent,Tags):
		wx.Dialog.__init__(self,parent,-1,'Mask test',size=(550,350),style=wx.RESIZE_BORDER|wx.CLOSE_BOX)
		self.CenterOnParent()
		self.List=TagTestList(self,Tags)
class TagTestList(wx.ListCtrl,ListCtrlAutoWidthMixin):
	def __init__(self,parent,Tags):
		wx.ListCtrl.__init__(self,parent,-1,style=wx.LC_REPORT|wx.LC_VRULES|wx.LC_HRULES)
		ListCtrlAutoWidthMixin.__init__(self)
		Columns=Tags[0][1].keys()
		self.InsertColumn(0,'Filename')
		self.ColumnPos={}
		for text in ['TITLE','ARTIST','ALBUM','TRACKNUMBER','YEAR','GENRE','COMMENT']:
			if text in Columns:
				self.CreateColumn(text)
		for tag in Tags:
			self.InsertStringItem(self.GetItemCount(),os.path.basename(tag[0]))
			for key in tag[1].keys():
				try:
					self.SetStringItem(self.GetItemCount()-1,self.ColumnPos[key],tag[1][key])
				except KeyError:
					pass
		for i in range(self.GetItemCount()):
			self.SetColumnWidth(i,wx.LIST_AUTOSIZE)
			if self.GetColumnWidth(i)<50:
				self.SetColumnWidth(i,50)
			elif self.GetColumnWidth(i)>250:
				self.SetColumnWidth(i,250)
	def CreateColumn(self,text):
		self.ColumnPos[text]=self.GetColumnCount()
		if text!='TRACKNUMBER':
			self.InsertColumn(self.GetColumnCount(),text.capitalize())
		else:
			self.InsertColumn(self.GetColumnCount(),'Track #')
