# Copyright (c) 2004-5 Marek Hnilica. All rights reserved.
# Module that provides 'convertor' dialog and functionality
# Distributed under GPL version 2, or (at your option) later

from wxPython.wx import *
import images,mp3,convert,wma
import os,os.path,string,glob,ogg.vorbis
import cPickle as pickle
from wxPython.gizmos import *

#---- <<<=== it means "copy here"
# Here isn't as much code as it might seem.
# 1/5 of code is hand-written work, the rest is just copy & paste of it,
# with some replacement text. (Low -> Lower, Ogg -> MP3, etc.)
# btw, this is so far the most boring thing i've done in my life :o(
ConvertorDataFile=(os.environ['HOME']+'/.mBox/.mBox.convertor.settings')

class BatchConvertor(wxDialog):
	def __init__(self,parent):
		wxDialog.__init__(self,parent,wxID_ANY,'Convertor',size=(400,400))
		self.parent=parent
		self.CenterOnParent()
		self.DirAdd=wxNewId()
		self.GoMP3=wxNewId()
		self.GoOGG=wxNewId()
		self.SettingsId=wxNewId()
		self.ToolPanel=wxPanel(self,wxNewId(),wxPoint(0,0),wxSize(400,30))
		self.ListPanel=wxPanel(self,wxNewId(),wxPoint(0,30),wxSize(400,370))
		self.ToolBar=wxToolBar(self.ToolPanel,-1,size=(400,30),style=wxNO_BORDER)
		self.ToolBar.AddSimpleTool(self.DirAdd,images.getDirectoryBitmap(),'Choose which directory to convert')
		self.ToolBar.AddSimpleTool(self.SettingsId,images.getsettingsBitmap(),'Settings')
		self.ToolBar.AddSeparator()
		self.ToolBar.AddSimpleTool(self.GoMP3,images.getmp3Bitmap(),'Convert to MP3')
		self.ToolBar.AddSimpleTool(self.GoOGG,images.getoggBitmap(),'Convert to Ogg Vorbis')
		self.List=TrackList(self.ListPanel)
		self.List.ListOfDirs=[]
		self.ToolBar.EnableTool(self.GoMP3,0)
		self.ToolBar.EnableTool(self.GoOGG,0)
		EVT_TOOL(self,self.DirAdd,self.OpenDir)
		EVT_TOOL(self,self.GoMP3,self.ConvertAllMP3)
		EVT_TOOL(self,self.GoOGG,self.ConvertAllOgg)
		EVT_TOOL(self,self.SettingsId,self.ShowSettingsDiag)

	def OpenDir(self,junk):
		self.dlg = wxDirDialog(self, "Choose a directory:")
		if self.dlg.ShowModal() == wxID_OK:
			self.dlg.Destroy()
			self.List.ReadDir(self.dlg.GetPath())
			if self.List<>[]:
				self.ToolBar.EnableTool(self.GoMP3,1)
				self.ToolBar.EnableTool(self.GoOGG,1)


	def ShowSettingsDiag(self,junk):
		self.EditSettingsDialog=SettingsDialog(self)
		self.EditSettingsDialog.ShowModal()

	def ConvertAllOgg(self,junk):
		StartDir=os.getcwd()
		SettingsLoad()
 		ProgDiag=wxProgressDialog("Please Wait...","Converting...",len(self.List.GetStrings())+1,self,wxPD_APP_MODAL|wxPD_CAN_ABORT)
 		Pos=0
		ErrorList=[]
		GoOn=1
		while GoOn and (Pos< len(self.List.GetStrings())):
			NameOfDir=self.List.GetStrings()[Pos]
 			GoOn=ProgDiag.Update(Pos,'converting dir %s of %s'%(Pos+1,len(self.List.GetStrings())))
			if not GoOn:
				break
			os.chdir(NameOfDir)
			mpegTrackList=glob.glob('*.[mM][pP]3*')
			oggTrackList=glob.glob('*.[oO][gG][gG]*')
			wmaTrackList=glob.glob('*.[wW][mM][aA]')
			if not mpegTrackList==[]:
				for mpegName in mpegTrackList:
					mpegInfo=mp3.detect_mp3(mpegName)
					if not mpegInfo==0:
						if mpegInfo['vbr']:
							self.bitrate=(mpegInfo['vbrrate'])
						else:
							self.bitrate=(mpegInfo['bitrate'])
					else:
	# If unable to read bitrate, set it so it doesn't make much harm
						self.bitrate=80
					self.OggEvaluateMpeg()
					try:
						convert.convert(mpegName,desired='ogg',flags=self.ConversionFlags)
					except convert.ConversionError,message:
						ErrorList.append(NameOfDir+'/'+mpegName+' : '+str(message))
			if not oggTrackList==[]:
				for oggName in oggTrackList:
					vorbFile=ogg.vorbis.VorbisFile(oggName)
					self.bitrate=int(vorbFile.bitrate(0)/1000)
					self.OggEvaluateOgg()
					try:
						convert.convert(oggName,desired='ogg',flags=self.ConversionFlags)
					except convert.ConversionError,message:
						ErrorList.append(NameOfDir+'/'+oggName+' : '+str(message))
			if not wmaTrackList==[]:
				for wmaName in wmaTrackList:
					self.bitrate=int(wma.Tag(wmaName)[7])
					self.OggEvaluateWma()
					try:
						convert.convert(wmaName,desired='ogg',flags=self.ConversionFlags)
					except convert.ConversionError,message:
						ErrorList.append(NameOfDir+'/'+wmaName+' : '+str(message))
			Pos+=1
		ProgDiag.Destroy()
		if not ErrorList==[]:
			MDiag=wxMessageDialog(self,string.join(ErrorList,'\n'),'These errors occured:',wxICON_WARNING|wxOK)
			MDiag.ShowModal()
			MDiag.Destroy()
		os.chdir(StartDir)

	def ConvertAllMP3(self,junk):
		StartDir=os.getcwd()
		SettingsLoad()
 		ProgDiag=wxProgressDialog("Please Wait...","Converting...",len(self.List.GetStrings())+1,self,wxPD_APP_MODAL|wxPD_CAN_ABORT)
 		Pos=0
		ErrorList=[]
		GoOn=1
		while GoOn and (Pos < len(self.List.GetStrings())):
			NameOfDir=self.List.GetStrings()[Pos]
 			GoOn=ProgDiag.Update(Pos,'converting dir %s of %s'%(Pos+1,len(self.List.GetStrings())))
			if not GoOn:
				break
			os.chdir(NameOfDir)
			mpegTrackList=glob.glob('*.[mM][pP]3*')
			oggTrackList=glob.glob('*.[oO][gG][gG]*')
			wmaTrackList=glob.glob('*.[wW][mM][aA]')
			if not mpegTrackList==[]:
				for mpegName in mpegTrackList:
					mpegInfo=mp3.detect_mp3(mpegName)
					if not mpegInfo==0:
						if mpegInfo['vbr']:
							self.bitrate=(mpegInfo['vbrrate'])
						else:
							self.bitrate=(mpegInfo['bitrate'])
					else:
	# If unable to read bitrate, set it so it doesn't make much harm
						self.bitrate=80
					self.MP3EvaluateMpegFile()
					try:
						convert.convert(mpegName,desired='mp3',flags=self.ConversionFlags)
					except convert.ConversionError,message:
						ErrorList.append(NameOfDir+'/'+mpegName+' : '+str(message))
			if not oggTrackList==[]:
				for oggName in oggTrackList:
					vorbFile=ogg.vorbis.VorbisFile(oggName)
					self.bitrate=int(vorbFile.bitrate(0)/1000)
					self.MP3EvaluateOggFile()
					try:
						convert.convert(oggName,desired='mp3',flags=self.ConversionFlags)
					except convert.ConversionError,message:
						ErrorList.append(NameOfDir+'/'+oggName+' : '+str(message))
			if not wmaTrackList==[]:
				for wmaName in wmaTrackList:
					self.bitrate=int(wma.Tag(wmaName)[7])
					self.MP3EvaluateWmaFile()
					try:
						convert.convert(wmaName,desired='mp3',flags=self.ConversionFlags)
					except convert.ConversionError,message:
						ErrorList.append(NameOfDir+'/'+wmaName+' : '+str(message))
			Pos+=1
		ProgDiag.Destroy()
		self.Refresh()
		self.Update()
		if not ErrorList==[]:
			MDiag=wxMessageDialog(self,string.join(ErrorList,'\n'),'These errors occured:',wxICON_WARNING|wxOK)
			MDiag.ShowModal()
			MDiag.Destroy()
		os.chdir(StartDir)
	
	def OggEvaluateMpeg(self):
		if self.bitrate<=OggFromMp3LowValue:
			if OggLowWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggLowQualityQualitySliderValue/100.0)
			if OggLowWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggLowQualityBitrateSliderValue
			if OggLowWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggLowQualitySizeMinSliderValue,OggLowQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromMp3LowerMinValue) and (self.bitrate<=OggFromMp3LowerMaxValue):
			if OggLowerWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggLowerQualityQualitySliderValue/100.0)
			if OggLowerWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggLowerQualityBitrateSliderValue
			if OggLowerWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggLowerQualitySizeMinSliderValue,OggLowerQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromMp3MediumMinValue) and (self.bitrate<=OggFromMp3MediumMaxValue):
			if OggMediumWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggMediumQualityQualitySliderValue/100.0)
			if OggMediumWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggMediumQualityBitrateSliderValue
			if OggMediumWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggMediumQualitySizeMinSliderValue,OggMediumQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromMp3HigherMinValue) and (self.bitrate<=OggFromMp3HigherMaxValue):
			if OggHigherWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggHigherQualityQualitySliderValue/100.0)
			if OggHigherWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggHigherQualityBitrateSliderValue
			if OggHigherWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggHigherQualitySizeMinSliderValue,OggHigherQualitySizeMaxSliderValue)
		if self.bitrate>=OggFromMp3HighValue:
			if OggHighWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggHighQualityQualitySliderValue/100.0)
			if OggHighWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggHighQualityBitrateSliderValue
			if OggHighWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggHighQualitySizeMinSliderValue,OggHighQualitySizeMaxSliderValue)

	def OggEvaluateWma(self):
		if self.bitrate<=OggFromWMALowValue:
			if OggLowWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggLowQualityQualitySliderValue/100.0)
			if OggLowWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggLowQualityBitrateSliderValue
			if OggLowWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggLowQualitySizeMinSliderValue,OggLowQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromWMALowerMinValue) and (self.bitrate<=OggFromWMALowerMaxValue):
			if OggLowerWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggLowerQualityQualitySliderValue/100.0)
			if OggLowerWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggLowerQualityBitrateSliderValue
			if OggLowerWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggLowerQualitySizeMinSliderValue,OggLowerQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromWMAMediumMinValue) and (self.bitrate<=OggFromWMAMediumMaxValue):
			if OggMediumWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggMediumQualityQualitySliderValue/100.0)
			if OggMediumWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggMediumQualityBitrateSliderValue
			if OggMediumWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggMediumQualitySizeMinSliderValue,OggMediumQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromWMAHigherMinValue) and (self.bitrate<=OggFromWMAHigherMaxValue):
			if OggHigherWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggHigherQualityQualitySliderValue/100.0)
			if OggHigherWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggHigherQualityBitrateSliderValue
			if OggHigherWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggHigherQualitySizeMinSliderValue,OggHigherQualitySizeMaxSliderValue)
		if self.bitrate>=OggFromWMAHighValue:
			if OggHighWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggHighQualityQualitySliderValue/100.0)
			if OggHighWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggHighQualityBitrateSliderValue
			if OggHighWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggHighQualitySizeMinSliderValue,OggHighQualitySizeMaxSliderValue)

	def OggEvaluateOgg(self):
		if self.bitrate<=OggFromOGGLowValue:
			if OggLowWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggLowQualityQualitySliderValue/100.0)
			if OggLowWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggLowQualityBitrateSliderValue
			if OggLowWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggLowQualitySizeMinSliderValue,OggLowQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromOGGLowerMinValue) and (self.bitrate<=OggFromOGGLowerMaxValue):
			if OggLowerWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggLowerQualityQualitySliderValue/100.0)
			if OggLowerWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggLowerQualityBitrateSliderValue
			if OggLowerWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggLowerQualitySizeMinSliderValue,OggLowerQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromOGGMediumMinValue) and (self.bitrate<=OggFromOGGMediumMaxValue):
			if OggMediumWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggMediumQualityQualitySliderValue/100.0)
			if OggMediumWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggMediumQualityBitrateSliderValue
			if OggMediumWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggMediumQualitySizeMinSliderValue,OggMediumQualitySizeMaxSliderValue)
		if (self.bitrate>=OggFromOGGHigherMinValue) and (self.bitrate<=OggFromOGGHigherMaxValue):
			if OggHigherWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggHigherQualityQualitySliderValue/100.0)
			if OggHigherWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggHigherQualityBitrateSliderValue
			if OggHigherWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggHigherQualitySizeMinSliderValue,OggHigherQualitySizeMaxSliderValue)
		if self.bitrate>=OggFromOGGHighValue:
			if OggHighWhichChecked=='quality':
				self.ConversionFlags='-q "%s"'%(OggHighQualityQualitySliderValue/100.0)
			if OggHighWhichChecked=='bitrate':
				self.ConversionFlags='-b "%s"'%OggHighQualityBitrateSliderValue
			if OggHighWhichChecked=='size':
				self.ConversionFlags='--managed -m "%s" -M "%s"'%(OggHighQualitySizeMinSliderValue,OggHighQualitySizeMaxSliderValue)

	def MP3EvaluateWmaFile(self):
		if self.bitrate<=MP3FromWMALowValue:
			if MP3LowQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3LowQualityBitrateAcoustic,MP3LowQualityBitrateValue)
				if MP3LowQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3LowQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3LowQualityQualityAcoustic,MP3LowQualityQualityValue)
				if MP3LowQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3LowQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3LowQualityQualityMaxQualityValue
				if MP3LowQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3LowQualityQualityMinQualityValue
				if MP3LowQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3LowQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3LowQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3LowQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3LowQualityABRAcoustic,MP3LowQualityABRSliderValue)
				if MP3LowQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromWMALowerMinValue) and (self.bitrate<=MP3FromWMALowerMaxValue):
			if MP3LowerQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3LowerQualityBitrateAcoustic,MP3LowerQualityBitrateValue)
				if MP3LowerQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3LowerQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3LowerQualityQualityAcoustic,MP3LowerQualityQualityValue)
				if MP3LowerQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3LowerQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3LowerQualityQualityMaxQualityValue
				if MP3LowerQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3LowerQualityQualityMinQualityValue
				if MP3LowerQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3LowerQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3LowerQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3LowerQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3LowerQualityABRAcoustic,MP3LowerQualityABRSliderValue)
				if MP3LowerQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromWMAMediumMinValue) and (self.bitrate<=MP3FromWMAMediumMaxValue):
			if MP3MediumQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3MediumQualityBitrateAcoustic,MP3MediumQualityBitrateValue)
				if MP3MediumQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3MediumQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3MediumQualityQualityAcoustic,MP3MediumQualityQualityValue)
				if MP3MediumQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3MediumQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3MediumQualityQualityMaxQualityValue
				if MP3MediumQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3MediumQualityQualityMinQualityValue
				if MP3MediumQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3MediumQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3MediumQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3MediumQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3MediumQualityABRAcoustic,MP3MediumQualityABRSliderValue)
				if MP3MediumQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromWMAHigherMinValue) and (self.bitrate<=MP3FromWMAHigherMaxValue):
			if MP3HigherQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3HigherQualityBitrateAcoustic,MP3HigherQualityBitrateValue)
				if MP3HigherQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3HigherQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3HigherQualityQualityAcoustic,MP3HigherQualityQualityValue)
				if MP3HigherQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3HigherQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3HigherQualityQualityMaxQualityValue
				if MP3HigherQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3HigherQualityQualityMinQualityValue
				if MP3HigherQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3HigherQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3HigherQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3HigherQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3HigherQualityABRAcoustic,MP3HigherQualityABRSliderValue)
				if MP3HigherQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if self.bitrate>=MP3FromWMAHighValue:
			if MP3HighQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3HighQualityBitrateAcoustic,MP3HighQualityBitrateValue)
				if MP3HighQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3HighQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3HighQualityQualityAcoustic,MP3HighQualityQualityValue)
				if MP3HighQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3HighQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3HighQualityQualityMaxQualityValue
				if MP3HighQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3HighQualityQualityMinQualityValue
				if MP3HighQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3HighQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3HighQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3HighQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3HighQualityABRAcoustic,MP3HighQualityABRSliderValue)
				if MP3HighQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'

	def MP3EvaluateOggFile(self):
		self.ConversionFlags=''
		if self.bitrate<=MP3FromOGGLowValue:
			if MP3LowQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3LowQualityBitrateAcoustic,MP3LowQualityBitrateValue)
				if MP3LowQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3LowQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3LowQualityQualityAcoustic,MP3LowQualityQualityValue)
				if MP3LowQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3LowQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3LowQualityQualityMaxQualityValue
				if MP3LowQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3LowQualityQualityMinQualityValue
				if MP3LowQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3LowQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3LowQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3LowQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3LowQualityABRAcoustic,MP3LowQualityABRSliderValue)
				if MP3LowQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromOGGLowerMinValue) and (self.bitrate<=MP3FromOGGLowerMaxValue):
			if MP3LowerQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3LowerQualityBitrateAcoustic,MP3LowerQualityBitrateValue)
				if MP3LowerQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3LowerQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3LowerQualityQualityAcoustic,MP3LowerQualityQualityValue)
				if MP3LowerQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3LowerQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3LowerQualityQualityMaxQualityValue
				if MP3LowerQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3LowerQualityQualityMinQualityValue
				if MP3LowerQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3LowerQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3LowerQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3LowerQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3LowerQualityABRAcoustic,MP3LowerQualityABRSliderValue)
				if MP3LowerQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromOGGMediumMinValue) and (self.bitrate<=MP3FromOGGMediumMaxValue):
			if MP3MediumQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3MediumQualityBitrateAcoustic,MP3MediumQualityBitrateValue)
				if MP3MediumQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3MediumQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3MediumQualityQualityAcoustic,MP3MediumQualityQualityValue)
				if MP3MediumQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3MediumQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3MediumQualityQualityMaxQualityValue
				if MP3MediumQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3MediumQualityQualityMinQualityValue
				if MP3MediumQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3MediumQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3MediumQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3MediumQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3MediumQualityABRAcoustic,MP3MediumQualityABRSliderValue)
				if MP3MediumQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromOGGHigherMinValue) and (self.bitrate<=MP3FromOGGHigherMaxValue):
			if MP3HigherQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3HigherQualityBitrateAcoustic,MP3HigherQualityBitrateValue)
				if MP3HigherQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3HigherQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3HigherQualityQualityAcoustic,MP3HigherQualityQualityValue)
				if MP3HigherQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3HigherQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3HigherQualityQualityMaxQualityValue
				if MP3HigherQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3HigherQualityQualityMinQualityValue
				if MP3HigherQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3HigherQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3HigherQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3HigherQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3HigherQualityABRAcoustic,MP3HigherQualityABRSliderValue)
				if MP3HigherQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if self.bitrate>=MP3FromOGGHighValue:
			if MP3HighQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3HighQualityBitrateAcoustic,MP3HighQualityBitrateValue)
				if MP3HighQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3HighQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3HighQualityQualityAcoustic,MP3HighQualityQualityValue)
				if MP3HighQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3HighQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3HighQualityQualityMaxQualityValue
				if MP3HighQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3HighQualityQualityMinQualityValue
				if MP3HighQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3HighQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3HighQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3HighQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3HighQualityABRAcoustic,MP3HighQualityABRSliderValue)
				if MP3HighQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'

	def MP3EvaluateMpegFile(self):
		if self.bitrate<=MP3FromMp3LowValue:
			if MP3LowQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3LowQualityBitrateAcoustic,MP3LowQualityBitrateValue)
				if MP3LowQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3LowQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3LowQualityQualityAcoustic,MP3LowQualityQualityValue)
				if MP3LowQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3LowQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3LowQualityQualityMaxQualityValue
				if MP3LowQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3LowQualityQualityMinQualityValue
				if MP3LowQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3LowQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3LowQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3LowQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3LowQualityABRAcoustic,MP3LowQualityABRSliderValue)
				if MP3LowQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromMp3LowerMinValue) and (self.bitrate<=MP3FromMp3LowerMaxValue):
			if MP3LowerQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3LowerQualityBitrateAcoustic,MP3LowerQualityBitrateValue)
				if MP3LowerQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3LowerQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3LowerQualityQualityAcoustic,MP3LowerQualityQualityValue)
				if MP3LowerQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3LowerQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3LowerQualityQualityMaxQualityValue
				if MP3LowerQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3LowerQualityQualityMinQualityValue
				if MP3LowerQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3LowerQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3LowerQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3LowerQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3LowerQualityABRAcoustic,MP3LowerQualityABRSliderValue)
				if MP3LowerQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3LowerQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3LowerQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromMp3MediumMinValue) and (self.bitrate<=MP3FromMp3MediumMaxValue):
			if MP3MediumQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3MediumQualityBitrateAcoustic,MP3MediumQualityBitrateValue)
				if MP3MediumQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3MediumQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3MediumQualityQualityAcoustic,MP3MediumQualityQualityValue)
				if MP3MediumQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3MediumQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3MediumQualityQualityMaxQualityValue
				if MP3MediumQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3MediumQualityQualityMinQualityValue
				if MP3MediumQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3MediumQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3MediumQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3MediumQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3MediumQualityABRAcoustic,MP3MediumQualityABRSliderValue)
				if MP3MediumQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3MediumQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3MediumQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if (self.bitrate>=MP3FromMp3HigherMinValue) and (self.bitrate<=MP3FromMp3HigherMaxValue):
			if MP3HigherQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3HigherQualityBitrateAcoustic,MP3HigherQualityBitrateValue)
				if MP3HigherQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3HigherQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3HigherQualityQualityAcoustic,MP3HigherQualityQualityValue)
				if MP3HigherQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3HigherQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3HigherQualityQualityMaxQualityValue
				if MP3HigherQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3HigherQualityQualityMinQualityValue
				if MP3HigherQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3HigherQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3HigherQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3HigherQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3HigherQualityABRAcoustic,MP3HigherQualityABRSliderValue)
				if MP3HigherQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HigherQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HigherQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
		if self.bitrate>=MP3FromMp3HighValue:
			if MP3HighQualityWhichType=='CBR':
				self.ConversionFlags='-q "%s" -b "%s"'%(MP3HighQualityBitrateAcoustic,MP3HighQualityBitrateValue)
				if MP3HighQualityBitrateModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityBitrateModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityBitrateModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
			elif MP3HighQualityWhichType=='VBR':
				self.ConversionFlags='-q "%s" -V "%s"'%(MP3HighQualityQualityAcoustic,MP3HighQualityQualityValue)
				if MP3HighQualityQualityModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityQualityModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityQualityModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'
				if MP3HighQualityQualityMaxCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -B "%s"'%MP3HighQualityQualityMaxQualityValue
				if MP3HighQualityQualityMinCheckControlStatus: self.ConversionFlags=self.ConversionFlags+' -b "%s"'%MP3HighQualityQualityMinQualityValue
				if MP3HighQualityQualityEnforceMinStatus: self.ConversionFlags=self.ConversionFlags+' "-F"'
				if MP3HighQualityQualityTypeValue=='new':self.ConversionFlags=self.ConversionFlags+' "--vbr-new"'
				elif MP3HighQualityQualityTypeValue=='old':self.ConversionFlags=self.ConversionFlags+' "--vbr-old"'
			elif MP3HighQualityWhichType=='ABR':
				self.ConversionFlags='-q "%s" --abr "%s"'%(MP3HighQualityABRAcoustic,MP3HighQualityABRSliderValue)
				if MP3HighQualityABRModeString == 'Joint-Stereo': self.ConversionFlags=self.ConversionFlags+' -m "j"'
				elif MP3HighQualityABRModeString == 'Stereo': self.ConversionFlags=self.ConversionFlags+' -m "s"'
				elif MP3HighQualityABRModeString == 'Mono': self.ConversionFlags=self.ConversionFlags+' -m "m"'

class TrackList(wxEditableListBox):
	def __init__(self,parent):
		wxEditableListBox.__init__(self,parent,wxNewId(),'List of directories that will be converted',wxPoint(0,0),wxSize(400,370),wxEL_ALLOW_DELETE)
		self.ListOfDirs=[]
		self.SetStrings(self.ListOfDirs)
  	def ListDirs(self,junk,dirname,junk2):
 		self.ListOfDirs.append(dirname)
 	def ReadDir(self,directory):
 		self.ListOfDirs=[]
 		os.path.walk(directory,self.ListDirs,None)
		self.ListOfDirs.sort()
 		self.SetStrings(self.ListOfDirs)
 	def deleted(self,junk):
 		print junk

class SettingsDialog(wxDialog):
	def __init__(self,parent):
		wxDialog.__init__(self,parent,-1,'Convertor settings')
  		self.MainNotebook=wxNotebook(self,-1)
		self.ToOgg=wxPanel(self.MainNotebook,wxNewId(),style=wxNO_BORDER)
		self.ToMP3=wxPanel(self.MainNotebook,wxNewId(),style=wxNO_BORDER)
		self.MainNotebook.AddPage(self.ToOgg,'To Ogg Vorbis settings')
		self.MainNotebook.AddPage(self.ToMP3,'To MP3 settings')
		SettingsLoad()
		self.OggPageFill()
		self.Mp3PageFill()
		EVT_BUTTON(self,self.MP3OkayButton.GetId(),self.OkPressed)
		EVT_BUTTON(self,self.OggOkayButton.GetId(),self.OkPressed)
		self.SetSize((600,500))
		self.CenterOnScreen()

	def WarningMessage(self,parent,text):
		self.Warning=wxMessageDialog(parent,text,'Configuration error',wxICON_WARNING)
		self.Warning.ShowModal()
		self.Warning.Destroy()
	def OkPressed(self,junk):
		if self.CloseSettings(''):
			self.SaveSettings()
			self.Hide()
	def CloseSettings(self,junk):
		self.CloseOkay=1
		self.WarningText=''
		OggFromMp3LowValue=self.OggFromMP3LowQualityValue.GetValue()
 		OggFromMp3LowerMinValue=self.OggFromMP3LowerMinValue.GetValue()
 		OggFromMp3LowerMaxValue=self.OggFromMP3LowerMaxValue.GetValue()
 		OggFromMp3MediumMinValue=self.OggFromMP3MediumMinValue.GetValue()
 		OggFromMp3MediumMaxValue=self.OggFromMP3MediumMaxValue.GetValue()
 		OggFromMp3HigherMinValue=self.OggFromMP3HigherMinValue.GetValue()
 		OggFromMp3HigherMaxValue=self.OggFromMP3HigherMaxValue.GetValue()
 		OggFromMp3HighValue=self.OggFromMP3HighValue.GetValue()
		if OggFromMp3LowValue+1 !=OggFromMp3LowerMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From MP3': Minimum of lower quality range must be Low quality + 1"
		if OggFromMp3LowerMaxValue+1 !=OggFromMp3MediumMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From MP3': Minimum of medium quality range must be maximum of lower quality range +1"
		if OggFromMp3MediumMaxValue+1 !=OggFromMp3HigherMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From MP3': Minimum of higher quality range must be maximum of medium quality range +1"
		if OggFromMp3HigherMaxValue+1 !=OggFromMp3HighValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From MP3': Minimum of higher quality range must be High quality +1"
		OggFromWMALowValue=self.OggFromWMALowValue.GetValue()
 		OggFromWMALowerMinValue=self.OggFromWMALowerMinValue.GetValue()
 		OggFromWMALowerMaxValue=self.OggFromWMALowerMaxValue.GetValue()
 		OggFromWMAMediumMinValue=self.OggFromWMAMediumMinValue.GetValue()
 		OggFromWMAMediumMaxValue=self.OggFromWMAMediumMaxValue.GetValue()
 		OggFromWMAHigherMinValue=self.OggFromWMAHigherMinValue.GetValue()
 		OggFromWMAHigherMaxValue=self.OggFromWMAHigherMaxValue.GetValue()
 		OggFromWMAHighValue=self.OggFromWMAHighValue.GetValue()
		if OggFromWMALowValue+1 !=OggFromWMALowerMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From WMA': Minimum of lower quality range must be Low quality + 1"
		if OggFromWMALowerMaxValue+1 !=OggFromWMAMediumMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From WMA': Minimum of medium quality range must be maximum of lower quality range +1"
		if OggFromWMAMediumMaxValue+1 !=OggFromWMAHigherMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From WMA': Minimum of higher quality range must be maximum of medium quality range +1"
		if OggFromWMAHigherMaxValue+1 !=OggFromWMAHighValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From WMA': Minimum of higher quality range must be High quality +1"
		OggFromOGGLowValue=self.OggFromOGGLowValue.GetValue()
 		OggFromOGGLowerMinValue=self.OggFromOGGLowerMinValue.GetValue()
 		OggFromOGGLowerMaxValue=self.OggFromOGGLowerMaxValue.GetValue()
 		OggFromOGGMediumMinValue=self.OggFromOGGMediumMinValue.GetValue()
 		OggFromOGGMediumMaxValue=self.OggFromOGGMediumMaxValue.GetValue()
 		OggFromOGGHigherMinValue=self.OggFromOGGHigherMinValue.GetValue()
 		OggFromOGGHigherMaxValue=self.OggFromOGGHigherMaxValue.GetValue()
 		OggFromOGGHighValue=self.OggFromOGGHighValue.GetValue()
		if OggFromOGGLowValue+1 !=OggFromOGGLowerMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Minimum of lower quality range must be Low quality + 1"
		if OggFromOGGLowerMaxValue+1 !=OggFromOGGMediumMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Minimum of medium quality range must be maximum of lower quality range +1"
		if OggFromOGGMediumMaxValue+1 !=OggFromOGGHigherMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Minimum of higher quality range must be maximum of medium quality range +1"
		if OggFromOGGHigherMaxValue+1 !=OggFromOGGHighValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Minimum of higher quality range must be High quality +1"
		if not self.OggHighQualitySizeMaxSlider.GetValue()-self.OggHighQualitySizeMinSlider.GetValue() >=4:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': High quality limits have wrong setting! Maximal value must be at least minimal +4"
		if not self.OggLowQualitySizeMaxSlider.GetValue()-self.OggLowQualitySizeMinSlider.GetValue()>=4:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Low quality limits have wrong setting! Maximal value must be at least minimal +4"
		if not self.OggLowerQualitySizeMaxSlider.GetValue()-self.OggLowerQualitySizeMinSlider.GetValue() >=4:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Lower quality limits have wrong setting! Maximal value must be at least minimal +4"
		if not self.OggMediumQualitySizeMaxSlider.GetValue()-self.OggMediumQualitySizeMinSlider.GetValue()>=4:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Medium quality limits have wrong setting! Maximal value must be at least minimal +4"
		if not self.OggHigherQualitySizeMaxSlider.GetValue()-self.OggHigherQualitySizeMinSlider.GetValue()>=4:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To Ogg page; part From OGG': Higher quality limits have wrong setting! Maximal value must be at least minimal +4"

#--------------
		MP3FromMp3LowValue=self.MP3FromMP3LowValue.GetValue()
 		MP3FromMp3LowerMinValue=self.MP3FromMP3LowerMinValue.GetValue()
 		MP3FromMp3LowerMaxValue=self.MP3FromMP3LowerMaxValue.GetValue()
 		MP3FromMp3MediumMinValue=self.MP3FromMP3MediumMinValue.GetValue()
 		MP3FromMp3MediumMaxValue=self.MP3FromMP3MediumMaxValue.GetValue()
 		MP3FromMp3HigherMinValue=self.MP3FromMP3HigherMinValue.GetValue()
 		MP3FromMp3HigherMaxValue=self.MP3FromMP3HigherMaxValue.GetValue()
 		MP3FromMp3HighValue=self.MP3FromMP3HighValue.GetValue()
		if MP3FromMp3LowValue+1 !=MP3FromMp3LowerMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From MP3': Minimum of lower quality range must be Low quality + 1"
		if MP3FromMp3LowerMaxValue+1 !=MP3FromMp3MediumMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From MP3': Minimum of medium quality range must be maximum of lower quality range +1"
		if MP3FromMp3MediumMaxValue+1 !=MP3FromMp3HigherMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From MP3': Minimum of higher quality range must be maximum of medium quality range +1"
		if MP3FromMp3HigherMaxValue+1 !=MP3FromMp3HighValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From MP3': Minimum of higher quality range must be High quality +1"
		MP3FromWMALowValue=self.MP3FromWMALowValue.GetValue()
 		MP3FromWMALowerMinValue=self.MP3FromWMALowerMinValue.GetValue()
 		MP3FromWMALowerMaxValue=self.MP3FromWMALowerMaxValue.GetValue()
 		MP3FromWMAMediumMinValue=self.MP3FromWMAMediumMinValue.GetValue()
 		MP3FromWMAMediumMaxValue=self.MP3FromWMAMediumMaxValue.GetValue()
 		MP3FromWMAHigherMinValue=self.MP3FromWMAHigherMinValue.GetValue()
 		MP3FromWMAHigherMaxValue=self.MP3FromWMAHigherMaxValue.GetValue()
 		MP3FromWMAHighValue=self.MP3FromWMAHighValue.GetValue()
		if MP3FromWMALowValue+1 !=MP3FromWMALowerMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From WMA': Minimum of lower quality range must be Low quality + 1"
		if MP3FromWMALowerMaxValue+1 !=MP3FromWMAMediumMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From WMA': Minimum of medium quality range must be maximum of lower quality range +1"
		if MP3FromWMAMediumMaxValue+1 !=MP3FromWMAHigherMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From WMA': Minimum of higher quality range must be maximum of medium quality range +1"
		if MP3FromWMAHigherMaxValue+1 !=MP3FromWMAHighValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From WMA': Minimum of higher quality range must be High quality +1"
		MP3FromOGGLowValue=self.MP3FromOGGLowValue.GetValue()
 		MP3FromOGGLowerMinValue=self.MP3FromOGGLowerMinValue.GetValue()
 		MP3FromOGGLowerMaxValue=self.MP3FromOGGLowerMaxValue.GetValue()
 		MP3FromOGGMediumMinValue=self.MP3FromOGGMediumMinValue.GetValue()
 		MP3FromOGGMediumMaxValue=self.MP3FromOGGMediumMaxValue.GetValue()
 		MP3FromOGGHigherMinValue=self.MP3FromOGGHigherMinValue.GetValue()
 		MP3FromOGGHigherMaxValue=self.MP3FromOGGHigherMaxValue.GetValue()
 		MP3FromOGGHighValue=self.MP3FromOGGHighValue.GetValue()
		if MP3FromOGGLowValue+1 !=MP3FromOGGLowerMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From OGG': Minimum of lower quality range must be Low quality + 1"
		if MP3FromOGGLowerMaxValue+1 !=MP3FromOGGMediumMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From OGG': Minimum of medium quality range must be maximum of lower quality range +1"
		if MP3FromOGGMediumMaxValue+1 !=MP3FromOGGHigherMinValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From OGG': Minimum of higher quality range must be maximum of medium quality range +1"
		if MP3FromOGGHigherMaxValue+1 !=MP3FromOGGHighValue:
			self.CloseOkay=0
			self.WarningText+="\nError at 'To MP3 page; part From OGG': Minimum of higher quality range must be High quality +1"
#--------------
		if self.CloseOkay:
			return 1
		else:
			self.WarningMessage(self,self.WarningText)
			return 0
	def save(self,data):
		pickle.dump(data,self.SaveFile)
	def SaveSettings(self):
		self.SaveFile=open(ConvertorDataFile,'w')
		self.save(self.MP3FromMP3LowValue.GetValue())
		self.save(self.MP3FromMP3LowerMinValue.GetValue())
		self.save(self.MP3FromMP3LowerMaxValue.GetValue())
		self.save(self.MP3FromMP3MediumMinValue.GetValue())
		self.save(self.MP3FromMP3MediumMaxValue.GetValue())
		self.save(self.MP3FromMP3HigherMinValue.GetValue())
		self.save(self.MP3FromMP3HigherMaxValue.GetValue())
		self.save(self.MP3FromMP3HighValue.GetValue())
		self.save(self.MP3FromWMALowValue.GetValue())
		self.save(self.MP3FromWMALowerMinValue.GetValue())
 		self.save(self.MP3FromWMALowerMaxValue.GetValue())
 		self.save(self.MP3FromWMAMediumMinValue.GetValue())
 		self.save(self.MP3FromWMAMediumMaxValue.GetValue())
 		self.save(self.MP3FromWMAHigherMinValue.GetValue())
 		self.save(self.MP3FromWMAHigherMaxValue.GetValue())
 		self.save(self.MP3FromWMAHighValue.GetValue())
		self.save(self.MP3FromOGGLowValue.GetValue())
 		self.save(self.MP3FromOGGLowerMinValue.GetValue())
 		self.save(self.MP3FromOGGLowerMaxValue.GetValue())
 		self.save(self.MP3FromOGGMediumMinValue.GetValue())
 		self.save(self.MP3FromOGGMediumMaxValue.GetValue())
 		self.save(self.MP3FromOGGHigherMinValue.GetValue())
 		self.save(self.MP3FromOGGHigherMaxValue.GetValue())
 		self.save(self.MP3FromOGGHighValue.GetValue())
		#----------------
		self.save(self.MP3LowQualityBitrateControl.GetValue())
		self.save(self.MP3LowQualityBitrateAcousticControl.GetValue())
		self.save(self.MP3LowQualityQualityType.GetStringSelection())
		self.save(self.MP3LowQualityQualityControl.GetValue())
		self.save(self.MP3LowQualityQualityAcousticControl.GetValue())
		self.save(self.MP3LowQualityQualityMinCheckControl.GetValue())
		self.save(self.MP3LowQualityQualityMinValue.GetValue())
		self.save(self.MP3LowQualityQualityMaxValue.GetValue())
		self.save(self.MP3LowQualityQualityMaxCheckControl.GetValue())
		self.save(self.MP3LowQualityQualityEnforceMinControl.GetValue())
		self.save(self.MP3LowQualityABRAcousticControl.GetValue())
		self.save(self.MP3LowQualityABRValue.GetValue())
		#----------------
		#----------------
		self.save(self.MP3LowerQualityBitrateControl.GetValue())
		self.save(self.MP3LowerQualityBitrateAcousticControl.GetValue())
		self.save(self.MP3LowerQualityQualityType.GetStringSelection())
		self.save(self.MP3LowerQualityQualityControl.GetValue())
		self.save(self.MP3LowerQualityQualityAcousticControl.GetValue())
		self.save(self.MP3LowerQualityQualityMinCheckControl.GetValue())
		self.save(self.MP3LowerQualityQualityMinValue.GetValue())
		self.save(self.MP3LowerQualityQualityMaxValue.GetValue())
		self.save(self.MP3LowerQualityQualityMaxCheckControl.GetValue())
		self.save(self.MP3LowerQualityQualityEnforceMinControl.GetValue())
		self.save(self.MP3LowerQualityABRAcousticControl.GetValue())
		self.save(self.MP3LowerQualityABRValue.GetValue())
		#----------------
		#----------------
		self.save(self.MP3MediumQualityBitrateControl.GetValue())
		self.save(self.MP3MediumQualityBitrateAcousticControl.GetValue())
		self.save(self.MP3MediumQualityQualityType.GetStringSelection())
		self.save(self.MP3MediumQualityQualityControl.GetValue())
		self.save(self.MP3MediumQualityQualityAcousticControl.GetValue())
		self.save(self.MP3MediumQualityQualityMinCheckControl.GetValue())
		self.save(self.MP3MediumQualityQualityMinValue.GetValue())
		self.save(self.MP3MediumQualityQualityMaxValue.GetValue())
		self.save(self.MP3MediumQualityQualityMaxCheckControl.GetValue())
		self.save(self.MP3MediumQualityQualityEnforceMinControl.GetValue())
		self.save(self.MP3MediumQualityABRAcousticControl.GetValue())
		self.save(self.MP3MediumQualityABRValue.GetValue())
		#----------------
		#----------------
		self.save(self.MP3HigherQualityBitrateControl.GetValue())
		self.save(self.MP3HigherQualityBitrateAcousticControl.GetValue())
		self.save(self.MP3HigherQualityQualityType.GetStringSelection())
		self.save(self.MP3HigherQualityQualityControl.GetValue())
		self.save(self.MP3HigherQualityQualityAcousticControl.GetValue())
		self.save(self.MP3HigherQualityQualityMinCheckControl.GetValue())
		self.save(self.MP3HigherQualityQualityMinValue.GetValue())
		self.save(self.MP3HigherQualityQualityMaxValue.GetValue())
		self.save(self.MP3HigherQualityQualityMaxCheckControl.GetValue())
		self.save(self.MP3HigherQualityQualityEnforceMinControl.GetValue())
		self.save(self.MP3HigherQualityABRAcousticControl.GetValue())
		self.save(self.MP3HigherQualityABRValue.GetValue())
		#----------------
		#----------------
		self.save(self.MP3HighQualityBitrateControl.GetValue())
		self.save(self.MP3HighQualityBitrateAcousticControl.GetValue())
		self.save(self.MP3HighQualityQualityType.GetStringSelection())
		self.save(self.MP3HighQualityQualityControl.GetValue())
		self.save(self.MP3HighQualityQualityAcousticControl.GetValue())
		self.save(self.MP3HighQualityQualityMinCheckControl.GetValue())
		self.save(self.MP3HighQualityQualityMinValue.GetValue())
		self.save(self.MP3HighQualityQualityMaxValue.GetValue())
		self.save(self.MP3HighQualityQualityMaxCheckControl.GetValue())
		self.save(self.MP3HighQualityQualityEnforceMinControl.GetValue())
		self.save(self.MP3HighQualityABRAcousticControl.GetValue())
		self.save(self.MP3HighQualityABRValue.GetValue())
		self.save(MP3LowQualityWhichType)
		self.save(MP3LowerQualityWhichType)
		self.save(MP3MediumQualityWhichType)
		self.save(MP3HigherQualityWhichType)
		self.save(MP3HighQualityWhichType)
		self.save(self.MP3LowQualityQualityMode.GetStringSelection())
		self.save(self.MP3LowQualityBitrateMode.GetStringSelection())
		self.save(self.MP3LowQualityABRMode.GetStringSelection())
		self.save(self.MP3LowerQualityQualityMode.GetStringSelection())
		self.save(self.MP3LowerQualityBitrateMode.GetStringSelection())
		self.save(self.MP3LowerQualityABRMode.GetStringSelection())
		self.save(self.MP3MediumQualityQualityMode.GetStringSelection())
		self.save(self.MP3MediumQualityBitrateMode.GetStringSelection())
		self.save(self.MP3MediumQualityABRMode.GetStringSelection())
		self.save(self.MP3HigherQualityQualityMode.GetStringSelection())
		self.save(self.MP3HigherQualityBitrateMode.GetStringSelection())
		self.save(self.MP3HigherQualityABRMode.GetStringSelection())
		self.save(self.MP3HighQualityQualityMode.GetStringSelection())
		self.save(self.MP3HighQualityBitrateMode.GetStringSelection())
		self.save(self.MP3HighQualityABRMode.GetStringSelection())
		#----------------
		self.save(self.OggFromMP3LowQualityValue.GetValue())
 		self.save(self.OggFromMP3LowerMinValue.GetValue())
 		self.save(self.OggFromMP3LowerMaxValue.GetValue())
 		self.save(self.OggFromMP3MediumMinValue.GetValue())
 		self.save(self.OggFromMP3MediumMaxValue.GetValue())
 		self.save(self.OggFromMP3HigherMinValue.GetValue())
 		self.save(self.OggFromMP3HigherMaxValue.GetValue())
 		self.save(self.OggFromMP3HighValue.GetValue())
		self.save(self.OggFromWMALowValue.GetValue())
 		self.save(self.OggFromWMALowerMinValue.GetValue())
 		self.save(self.OggFromWMALowerMaxValue.GetValue())
 		self.save(self.OggFromWMAMediumMinValue.GetValue())
 		self.save(self.OggFromWMAMediumMaxValue.GetValue())
 		self.save(self.OggFromWMAHigherMinValue.GetValue())
 		self.save(self.OggFromWMAHigherMaxValue.GetValue())
 		self.save(self.OggFromWMAHighValue.GetValue())
		self.save(self.OggFromOGGLowValue.GetValue())
 		self.save(self.OggFromOGGLowerMinValue.GetValue())
 		self.save(self.OggFromOGGLowerMaxValue.GetValue())
 		self.save(self.OggFromOGGMediumMinValue.GetValue())
 		self.save(self.OggFromOGGMediumMaxValue.GetValue())
 		self.save(self.OggFromOGGHigherMinValue.GetValue())
 		self.save(self.OggFromOGGHigherMaxValue.GetValue())
 		self.save(self.OggFromOGGHighValue.GetValue())
		#---
		self.save(self.OggLowQualityQualitySlider.GetValue())
		self.save(self.OggLowQualityBitrateSlider.GetValue())
		self.save(self.OggLowQualitySizeMinSlider.GetValue())
		self.save(self.OggLowQualitySizeMaxSlider.GetValue())
		#---
		self.save(self.OggLowerQualityQualitySlider.GetValue())
		self.save(self.OggLowerQualityBitrateSlider.GetValue())
		self.save(self.OggLowerQualitySizeMinSlider.GetValue())
		self.save(self.OggLowerQualitySizeMaxSlider.GetValue())
		#---
		self.save(self.OggMediumQualityQualitySlider.GetValue())
		self.save(self.OggMediumQualityBitrateSlider.GetValue())
		self.save(self.OggMediumQualitySizeMinSlider.GetValue())
		self.save(self.OggMediumQualitySizeMaxSlider.GetValue())
		#---
		self.save(self.OggHigherQualityQualitySlider.GetValue())
		self.save(self.OggHigherQualityBitrateSlider.GetValue())
		self.save(self.OggHigherQualitySizeMinSlider.GetValue())
		self.save(self.OggHigherQualitySizeMaxSlider.GetValue())
		#---
		self.save(self.OggHighQualityQualitySlider.GetValue())
		self.save(self.OggHighQualityBitrateSlider.GetValue())
		self.save(self.OggHighQualitySizeMinSlider.GetValue())
		self.save(self.OggHighQualitySizeMaxSlider.GetValue())
		self.save(OggLowWhichChecked)
		self.save(OggLowerWhichChecked)
		self.save(OggMediumWhichChecked)
		self.save(OggHigherWhichChecked)
		self.save(OggHighWhichChecked)
		self.SaveFile.close()
	def Mp3PageFill(self):
		self.MP3FromMP3button=wxRadioButton(self.ToMP3,wxNewId(),'From MP3',wxPoint(1,40),style=wxRB_GROUP)
		self.MP3FromWMAbutton=wxRadioButton(self.ToMP3,wxNewId(),'From WMA',wxPoint(1,70))
		self.MP3FromOGGbutton=wxRadioButton(self.ToMP3,wxNewId(),'From OGG',wxPoint(1,100))
		self.MP3LowQualitybutton=wxRadioButton(self.ToMP3,wxNewId(),'Low Quality',wxPoint(1,160))
		self.MP3LowerQualitybutton=wxRadioButton(self.ToMP3,wxNewId(),'Lower Quality',wxPoint(1,190))
		self.MP3MediumQualitybutton=wxRadioButton(self.ToMP3,wxNewId(),'Medium Quality',wxPoint(1,220))
		self.MP3HigherQualitybutton=wxRadioButton(self.ToMP3,wxNewId(),'Higher Quality',wxPoint(1,250))
		self.MP3HighQualitybutton=wxRadioButton(self.ToMP3,wxNewId(),'High Quality',wxPoint(1,280))
		self.MP3OkayButton=wxButton(self.ToMP3,wxNewId(),'Save',wxPoint(10,350))
#----------
		self.MP3FromMP3MainPanel=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3FromMP3TextPanel=wxPanel(self.MP3FromMP3MainPanel,-1,wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3FromMP3=wxPanel(self.MP3FromMP3MainPanel,-1,wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3FromMP3HeadingText=wxStaticText(self.MP3FromMP3TextPanel,-1,'From MP3 to MP3:',wxPoint(10,10))
		self.MP3FromMP3HeadingText.SetFont(wxFont(18, wxSWISS, wxNORMAL, wxNORMAL))
		self.MP3FromMP3LowQualityText=wxStaticText(self.MP3FromMP3,-1,'Low quality',wxPoint(10,10))
		self.MP3FromMP3LowQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromMP3,-1,'maximal:',wxPoint(180,10))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,10))
		self.MP3FromMP3LowValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,7),wxSize(50,20))
		self.MP3FromMP3LowValue.SetRange(8,320)
		self.MP3FromMP3LowValue.SetValue(MP3FromMp3LowValue)
###
		self.MP3FromMP3LowerQualityText=wxStaticText(self.MP3FromMP3,-1,'Lower quality range',wxPoint(10,60))
		self.MP3FromMP3LowerQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromMP3,-1,'minimum:',wxPoint(180,60))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,60))
		self.MP3FromMP3LowerMinValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,57),wxSize(50,20))
		self.MP3FromMP3LowerMinValue.SetRange(8,320)
		self.MP3FromMP3LowerMinValue.SetValue(MP3FromMp3LowerMinValue)
		wxStaticText(self.MP3FromMP3,-1,'maximum:',wxPoint(180,80))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,80))
		self.MP3FromMP3LowerMaxValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,77),wxSize(50,20))
		self.MP3FromMP3LowerMaxValue.SetRange(8,320)
		self.MP3FromMP3LowerMaxValue.SetValue(MP3FromMp3LowerMaxValue)
###
		self.MP3FromMP3MediumQualityText=wxStaticText(self.MP3FromMP3,-1,'Medium quality range',wxPoint(10,110))
		self.MP3FromMP3MediumQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromMP3,-1,'minimum:',wxPoint(180,110))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,110))
		self.MP3FromMP3MediumMinValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,107),wxSize(50,20))
		self.MP3FromMP3MediumMinValue.SetRange(8,320)
		self.MP3FromMP3MediumMinValue.SetValue(MP3FromMp3MediumMinValue)
		wxStaticText(self.MP3FromMP3,-1,'maximum:',wxPoint(180,130))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,130))
		self.MP3FromMP3MediumMaxValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,127),wxSize(50,20))
		self.MP3FromMP3MediumMaxValue.SetRange(8,320)
		self.MP3FromMP3MediumMaxValue.SetValue(MP3FromMp3MediumMaxValue)
###
		self.MP3FromMP3HigherQualityText=wxStaticText(self.MP3FromMP3,-1,'Higher quality range',wxPoint(10,160))
		self.MP3FromMP3HigherQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromMP3,-1,'minimum:',wxPoint(180,160))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,160))
		self.MP3FromMP3HigherMinValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,157),wxSize(50,20))
		self.MP3FromMP3HigherMinValue.SetRange(8,320)
		self.MP3FromMP3HigherMinValue.SetValue(MP3FromMp3HigherMinValue)
		wxStaticText(self.MP3FromMP3,-1,'maximum:',wxPoint(180,180))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,180))
		self.MP3FromMP3HigherMaxValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,177),wxSize(50,20))
		self.MP3FromMP3HigherMaxValue.SetRange(8,320)
		self.MP3FromMP3HigherMaxValue.SetValue(MP3FromMp3HigherMaxValue)
###
		self.MP3FromMP3HighQualityText=wxStaticText(self.MP3FromMP3,-1,'High quality',wxPoint(10,210))
		self.MP3FromMP3HighQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromMP3,-1,'at least:',wxPoint(180,210))
		wxStaticText(self.MP3FromMP3,-1,'kbps',wxPoint(335,210))
		self.MP3FromMP3HighValue=wxSpinCtrl(self.MP3FromMP3,wxNewId(),'',wxPoint(280,207),wxSize(50,20))
		self.MP3FromMP3HighValue.SetRange(8,320)
		self.MP3FromMP3HighValue.SetValue(MP3FromMp3HighValue)
#----------
#----------
		self.MP3FromWMAMainPanel=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3FromWMATextPanel=wxPanel(self.MP3FromWMAMainPanel,-1,wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3FromWMA=wxPanel(self.MP3FromWMAMainPanel,-1,wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3FromWMAHeadingText=wxStaticText(self.MP3FromWMATextPanel,-1,'From WMA to MP3:',wxPoint(10,10))
		self.MP3FromWMAHeadingText.SetFont(wxFont(18, wxSWISS, wxNORMAL, wxNORMAL))
		self.MP3FromWMALowQualityText=wxStaticText(self.MP3FromWMA,-1,'Low quality',wxPoint(10,10))
		self.MP3FromWMALowQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromWMA,-1,'maximal:',wxPoint(180,10))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,10))
		self.MP3FromWMALowValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,7),wxSize(50,20))
		self.MP3FromWMALowValue.SetRange(8,320)
		self.MP3FromWMALowValue.SetValue(MP3FromWMALowValue)
###
		self.MP3FromWMALowerQualityText=wxStaticText(self.MP3FromWMA,-1,'Lower quality range',wxPoint(10,60))
		self.MP3FromWMALowerQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromWMA,-1,'minimum:',wxPoint(180,60))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,60))
		self.MP3FromWMALowerMinValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,57),wxSize(50,20))
		self.MP3FromWMALowerMinValue.SetRange(8,320)
		self.MP3FromWMALowerMinValue.SetValue(MP3FromWMALowerMinValue)
		wxStaticText(self.MP3FromWMA,-1,'maximum:',wxPoint(180,80))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,80))
		self.MP3FromWMALowerMaxValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,77),wxSize(50,20))
		self.MP3FromWMALowerMaxValue.SetRange(8,320)
		self.MP3FromWMALowerMaxValue.SetValue(MP3FromWMALowerMaxValue)
###
		self.MP3FromWMAMediumQualityText=wxStaticText(self.MP3FromWMA,-1,'Medium quality range',wxPoint(10,110))
		self.MP3FromWMAMediumQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromWMA,-1,'minimum:',wxPoint(180,110))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,110))
		self.MP3FromWMAMediumMinValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,107),wxSize(50,20))
		self.MP3FromWMAMediumMinValue.SetRange(8,320)
		self.MP3FromWMAMediumMinValue.SetValue(MP3FromWMAMediumMinValue)
		wxStaticText(self.MP3FromWMA,-1,'maximum:',wxPoint(180,130))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,130))
		self.MP3FromWMAMediumMaxValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,127),wxSize(50,20))
		self.MP3FromWMAMediumMaxValue.SetRange(8,320)
		self.MP3FromWMAMediumMaxValue.SetValue(MP3FromWMAMediumMaxValue)
###
		self.MP3FromWMAHigherQualityText=wxStaticText(self.MP3FromWMA,-1,'Higher quality range',wxPoint(10,160))
		self.MP3FromWMAHigherQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromWMA,-1,'minimum:',wxPoint(180,160))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,160))
		self.MP3FromWMAHigherMinValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,157),wxSize(50,20))
		self.MP3FromWMAHigherMinValue.SetRange(8,320)
		self.MP3FromWMAHigherMinValue.SetValue(MP3FromWMAHigherMinValue)
		wxStaticText(self.MP3FromWMA,-1,'maximum:',wxPoint(180,180))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,180))
		self.MP3FromWMAHigherMaxValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,177),wxSize(50,20))
		self.MP3FromWMAHigherMaxValue.SetRange(8,320)
		self.MP3FromWMAHigherMaxValue.SetValue(MP3FromWMAHigherMaxValue)
###
		self.MP3FromWMAHighQualityText=wxStaticText(self.MP3FromWMA,-1,'High quality',wxPoint(10,210))
		self.MP3FromWMAHighQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromWMA,-1,'at least:',wxPoint(180,210))
		wxStaticText(self.MP3FromWMA,-1,'kbps',wxPoint(335,210))
		self.MP3FromWMAHighValue=wxSpinCtrl(self.MP3FromWMA,wxNewId(),'',wxPoint(280,207),wxSize(50,20))
		self.MP3FromWMAHighValue.SetRange(8,320)
		self.MP3FromWMAHighValue.SetValue(MP3FromWMAHighValue)

#----------
#----------
		self.MP3FromOGGMainPanel=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3FromOGGTextPanel=wxPanel(self.MP3FromOGGMainPanel,-1,wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3FromOGG=wxPanel(self.MP3FromOGGMainPanel,-1,wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3FromOGGHeadingText=wxStaticText(self.MP3FromOGGTextPanel,-1,'From Ogg to MP3:',wxPoint(10,10))
		self.MP3FromOGGHeadingText.SetFont(wxFont(18, wxSWISS, wxNORMAL, wxNORMAL))
		self.MP3FromOGGLowQualityText=wxStaticText(self.MP3FromOGG,-1,'Low quality',wxPoint(10,10))
		self.MP3FromOGGLowQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromOGG,-1,'maximal:',wxPoint(180,10))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,10))
		self.MP3FromOGGLowValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,7),wxSize(50,20))
		self.MP3FromOGGLowValue.SetRange(8,320)
		self.MP3FromOGGLowValue.SetValue(MP3FromOGGLowValue)
###
		self.MP3FromOGGLowerQualityText=wxStaticText(self.MP3FromOGG,-1,'Lower quality range',wxPoint(10,60))
		self.MP3FromOGGLowerQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromOGG,-1,'minimum:',wxPoint(180,60))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,60))
		self.MP3FromOGGLowerMinValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,57),wxSize(50,20))
		self.MP3FromOGGLowerMinValue.SetRange(8,320)
		self.MP3FromOGGLowerMinValue.SetValue(MP3FromOGGLowerMinValue)
		wxStaticText(self.MP3FromOGG,-1,'maximum:',wxPoint(180,80))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,80))
		self.MP3FromOGGLowerMaxValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,77),wxSize(50,20))
		self.MP3FromOGGLowerMaxValue.SetRange(8,320)
		self.MP3FromOGGLowerMaxValue.SetValue(MP3FromOGGLowerMaxValue)
###
		self.MP3FromOGGMediumQualityText=wxStaticText(self.MP3FromOGG,-1,'Medium quality range',wxPoint(10,110))
		self.MP3FromOGGMediumQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromOGG,-1,'minimum:',wxPoint(180,110))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,110))
		self.MP3FromOGGMediumMinValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,107),wxSize(50,20))
		self.MP3FromOGGMediumMinValue.SetRange(8,320)
		self.MP3FromOGGMediumMinValue.SetValue(MP3FromOGGMediumMinValue)
		wxStaticText(self.MP3FromOGG,-1,'maximum:',wxPoint(180,130))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,130))
		self.MP3FromOGGMediumMaxValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,127),wxSize(50,20))
		self.MP3FromOGGMediumMaxValue.SetRange(8,320)
		self.MP3FromOGGMediumMaxValue.SetValue(MP3FromOGGMediumMaxValue)
###
		self.MP3FromOGGHigherQualityText=wxStaticText(self.MP3FromOGG,-1,'Higher quality range',wxPoint(10,160))
		self.MP3FromOGGHigherQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromOGG,-1,'minimum:',wxPoint(180,160))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,160))
		self.MP3FromOGGHigherMinValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,157),wxSize(50,20))
		self.MP3FromOGGHigherMinValue.SetRange(8,320)
		self.MP3FromOGGHigherMinValue.SetValue(MP3FromOGGHigherMinValue)
		wxStaticText(self.MP3FromOGG,-1,'maximum:',wxPoint(180,180))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,180))
		self.MP3FromOGGHigherMaxValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,177),wxSize(50,20))
		self.MP3FromOGGHigherMaxValue.SetRange(8,320)
		self.MP3FromOGGHigherMaxValue.SetValue(MP3FromOGGHigherMaxValue)
###
		self.MP3FromOGGHighQualityText=wxStaticText(self.MP3FromOGG,-1,'High quality',wxPoint(10,210))
		self.MP3FromOGGHighQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.MP3FromOGG,-1,'at least:',wxPoint(180,210))
		wxStaticText(self.MP3FromOGG,-1,'kbps',wxPoint(335,210))
		self.MP3FromOGGHighValue=wxSpinCtrl(self.MP3FromOGG,wxNewId(),'',wxPoint(280,207),wxSize(50,20))
		self.MP3FromOGGHighValue.SetRange(8,320)
		self.MP3FromOGGHighValue.SetValue(MP3FromOGGHighValue)

#----------
		self.MP3LowQuality=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3LowQualityUpperPanel=wxPanel(self.MP3LowQuality,wxNewId(),wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3LowQualityQualityButton=wxRadioButton(self.MP3LowQualityUpperPanel,wxNewId(),'VBR',wxPoint(50,0),style=wxRB_GROUP)
		self.MP3LowQualityBitrateButton=wxRadioButton(self.MP3LowQualityUpperPanel,wxNewId(),'CBR',wxPoint(110,0))
		self.MP3LowQualityAverageButton=wxRadioButton(self.MP3LowQualityUpperPanel,wxNewId(),'ABR',wxPoint(170,0))
		self.MP3LowQualityQualityPanel=wxPanel(self.MP3LowQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3LowQualityQualityMode=wxRadioBox(self.MP3LowQualityQualityPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3LowQualityQualityMode.SetStringSelection(MP3LowQualityQualityModeString)
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'Poor',wxPoint(180,280))
		self.MP3LowQualityQualityAcousticControl=wxSlider(self.MP3LowQualityQualityPanel, wxNewId(), MP3LowQualityQualityAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		self.MP3LowQualityQualityType=wxRadioBox(self.MP3LowQualityQualityPanel,wxNewId(), "VBR type",wxPoint(1,1),wxSize(220,50),['new','old'], 2, wxRA_SPECIFY_COLS)
		self.MP3LowQualityQualityType.SetStringSelection(MP3LowQualityQualityTypeValue)
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'VBR quality setting:',wxPoint(1,54))
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'High',wxPoint(10,85))
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'Poor',wxPoint(165,85))
		self.MP3LowQualityQualityControl=wxSlider(self.MP3LowQualityQualityPanel, wxNewId(),MP3LowQualityQualityValue , 0, 9, wxPoint(40, 67),wxSize(120, 10),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'Allowed bitrate (use with caution!):',wxPoint(1,125))
		self.MP3LowQualityQualityMinCheckControl=wxCheckBox(self.MP3LowQualityQualityPanel, wxNewId(),'Min',wxPoint(10,150))
		self.MP3LowQualityQualityMinCheckControl.SetValue(MP3LowQualityQualityMinCheckControlStatus)
		wxStaticText(self.MP3LowQualityQualityPanel,-1,'kbps',wxPoint(135,155))
  		self.MP3LowQualityQualityMinValue=wxComboBox(self.MP3LowQualityQualityPanel,wxNewId(),MP3LowQualityQualityMinQualityValue,wxPoint(60,150),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
  		self.MP3LowQualityQualityMinValue.SetEditable(0)
		self.MP3LowQualityQualityMinValue.Enable(MP3LowQualityQualityMinCheckControlStatus)
  		wxStaticText(self.MP3LowQualityQualityPanel,-1,'kbps',wxPoint(135,185))
		self.MP3LowQualityQualityMaxCheckControl=wxCheckBox(self.MP3LowQualityQualityPanel, wxNewId(),'Max',wxPoint(10,180))
  		self.MP3LowQualityQualityMaxValue=wxComboBox(self.MP3LowQualityQualityPanel,wxNewId(),MP3LowQualityQualityMaxQualityValue,wxPoint(60,180),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
 		self.MP3LowQualityQualityEnforceMinControl=wxCheckBox(self.MP3LowQualityQualityPanel, wxNewId(),'Enforce minimal bitrate',wxPoint(10,200))
  		self.MP3LowQualityQualityMaxCheckControl.SetValue(MP3LowQualityQualityMaxCheckControlStatus)
 		self.MP3LowQualityQualityMaxValue.SetEditable(0)
 		self.MP3LowQualityQualityMaxValue.Enable(MP3LowQualityQualityMaxCheckControlStatus)
 		self.MP3LowQualityQualityEnforceMinControl.SetValue(MP3LowQualityQualityEnforceMinStatus)
 		self.MP3LowQualityQualityEnforceMinControl.Enable(MP3LowQualityQualityMinCheckControlStatus)
		EVT_CHECKBOX(self.MP3LowQualityQualityMinCheckControl,self.MP3LowQualityQualityMinCheckControl.GetId(),self.MP3LowQualityQualityMinEnable)
		EVT_CHECKBOX(self.MP3LowQualityQualityMaxCheckControl,self.MP3LowQualityQualityMaxCheckControl.GetId(),self.MP3LowQualityQualityMaxEnable)

		self.MP3LowQualityBitratePanel=wxPanel(self.MP3LowQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3LowQualityBitrateMode=wxRadioBox(self.MP3LowQualityBitratePanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3LowQualityBitrateMode.SetStringSelection(MP3LowQualityBitrateModeString)
		wxStaticText(self.MP3LowQualityBitratePanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3LowQualityBitratePanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3LowQualityBitratePanel,-1,'Poor',wxPoint(180,280))
		self.MP3LowQualityBitrateAcousticControl=wxSlider(self.MP3LowQualityBitratePanel, wxNewId(), MP3LowQualityBitrateAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3LowQualityBitratePanel,-1,'Bitrate:',wxPoint(0,5))
		wxStaticText(self.MP3LowQualityBitratePanel,-1,'kbps',wxPoint(150,5))
		self.MP3LowQualityBitrateControl=wxComboBox(self.MP3LowQualityBitratePanel,wxNewId(),MP3LowQualityBitrateValue,wxPoint(50, 0),wxSize(95, -1),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'])
		self.MP3LowQualityBitrateControl.SetEditable(0)

		self.MP3LowQualityABRPanel=wxPanel(self.MP3LowQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3LowQualityABRMode=wxRadioBox(self.MP3LowQualityABRPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3LowQualityABRMode.SetStringSelection(MP3LowQualityABRModeString)
		wxStaticText(self.MP3LowQualityABRPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3LowQualityABRPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3LowQualityABRPanel,-1,'Poor',wxPoint(180,280))
		self.MP3LowQualityABRAcousticControl=wxSlider(self.MP3LowQualityABRPanel, wxNewId(), MP3LowQualityABRAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3LowQualityABRPanel,-1,'ABR nominal bitrate:',wxPoint(0,0))
		wxStaticText(self.MP3LowQualityABRPanel,-1,'kbps',wxPoint(140,50))
		self.MP3LowQualityABRValue=wxSlider(self.MP3LowQualityABRPanel,wxNewId(),MP3LowQualityABRSliderValue,32,320,wxPoint(10,30),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)

		EVT_RADIOBUTTON(self.MP3LowQualityQualityButton,self.MP3LowQualityQualityButton.GetId(),self.ShowMP3LowQualityQuality)
		EVT_RADIOBUTTON(self.MP3LowQualityBitrateButton,self.MP3LowQualityBitrateButton.GetId(),self.ShowMP3LowQualityBitrate)
		EVT_RADIOBUTTON(self.MP3LowQualityAverageButton,self.MP3LowQualityAverageButton.GetId(),self.ShowMP3LowQualityABR)
		if MP3LowQualityWhichType=='VBR':
			self.MP3LowQualityQualityButton.SetValue(1)
			self.MP3LowQualityBitrateButton.SetValue(0)
			self.MP3LowQualityAverageButton.SetValue(0)
			self.ShowMP3LowQualityQuality('')
		if MP3LowQualityWhichType=='CBR':
			self.MP3LowQualityQualityButton.SetValue(0)
			self.MP3LowQualityBitrateButton.SetValue(1)
			self.MP3LowQualityAverageButton.SetValue(0)
			self.ShowMP3LowQualityBitrate('')
		if MP3LowQualityWhichType=='ABR':
			self.MP3LowQualityQualityButton.SetValue(0)
			self.MP3LowQualityBitrateButton.SetValue(0)
			self.MP3LowQualityAverageButton.SetValue(1)
			self.ShowMP3LowQualityABR('')


#----------
#----------
		self.MP3LowerQuality=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3LowerQualityUpperPanel=wxPanel(self.MP3LowerQuality,wxNewId(),wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3LowerQualityQualityButton=wxRadioButton(self.MP3LowerQualityUpperPanel,wxNewId(),'VBR',wxPoint(50,0),style=wxRB_GROUP)
		self.MP3LowerQualityBitrateButton=wxRadioButton(self.MP3LowerQualityUpperPanel,wxNewId(),'CBR',wxPoint(110,0))
		self.MP3LowerQualityAverageButton=wxRadioButton(self.MP3LowerQualityUpperPanel,wxNewId(),'ABR',wxPoint(170,0))
		self.MP3LowerQualityQualityPanel=wxPanel(self.MP3LowerQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3LowerQualityQualityMode=wxRadioBox(self.MP3LowerQualityQualityPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3LowerQualityQualityMode.SetStringSelection(MP3LowerQualityQualityModeString)
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'Poor',wxPoint(180,280))
		self.MP3LowerQualityQualityAcousticControl=wxSlider(self.MP3LowerQualityQualityPanel, wxNewId(), MP3LowerQualityQualityAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		self.MP3LowerQualityQualityType=wxRadioBox(self.MP3LowerQualityQualityPanel,wxNewId(), "VBR type",wxPoint(1,1),wxSize(220,50),['new','old'], 2, wxRA_SPECIFY_COLS)
		self.MP3LowerQualityQualityType.SetStringSelection(MP3LowerQualityQualityTypeValue)
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'VBR quality setting:',wxPoint(1,54))
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'High',wxPoint(10,85))
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'Poor',wxPoint(165,85))
		self.MP3LowerQualityQualityControl=wxSlider(self.MP3LowerQualityQualityPanel, wxNewId(),MP3LowerQualityQualityValue , 0, 9, wxPoint(40, 67),wxSize(120, 10),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'Allowed bitrate (use with caution!):',wxPoint(1,125))
		self.MP3LowerQualityQualityMinCheckControl=wxCheckBox(self.MP3LowerQualityQualityPanel, wxNewId(),'Min',wxPoint(10,150))
		self.MP3LowerQualityQualityMinCheckControl.SetValue(MP3LowerQualityQualityMinCheckControlStatus)
		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'kbps',wxPoint(135,155))
  		self.MP3LowerQualityQualityMinValue=wxComboBox(self.MP3LowerQualityQualityPanel,wxNewId(),MP3LowerQualityQualityMinQualityValue,wxPoint(60,150),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
  		self.MP3LowerQualityQualityMinValue.SetEditable(0)
		self.MP3LowerQualityQualityMinValue.Enable(MP3LowerQualityQualityMinCheckControlStatus)
  		wxStaticText(self.MP3LowerQualityQualityPanel,-1,'kbps',wxPoint(135,185))
		self.MP3LowerQualityQualityMaxCheckControl=wxCheckBox(self.MP3LowerQualityQualityPanel, wxNewId(),'Max',wxPoint(10,180))
  		self.MP3LowerQualityQualityMaxValue=wxComboBox(self.MP3LowerQualityQualityPanel,wxNewId(),MP3LowerQualityQualityMaxQualityValue,wxPoint(60,180),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
 		self.MP3LowerQualityQualityEnforceMinControl=wxCheckBox(self.MP3LowerQualityQualityPanel, wxNewId(),'Enforce minimal bitrate',wxPoint(10,200))
  		self.MP3LowerQualityQualityMaxCheckControl.SetValue(MP3LowerQualityQualityMaxCheckControlStatus)
 		self.MP3LowerQualityQualityMaxValue.SetEditable(0)
 		self.MP3LowerQualityQualityMaxValue.Enable(MP3LowerQualityQualityMaxCheckControlStatus)
 		self.MP3LowerQualityQualityEnforceMinControl.SetValue(MP3LowerQualityQualityEnforceMinStatus)
 		self.MP3LowerQualityQualityEnforceMinControl.Enable(MP3LowerQualityQualityMinCheckControlStatus)
		EVT_CHECKBOX(self.MP3LowerQualityQualityMinCheckControl,self.MP3LowerQualityQualityMinCheckControl.GetId(),self.MP3LowerQualityQualityMinEnable)
		EVT_CHECKBOX(self.MP3LowerQualityQualityMaxCheckControl,self.MP3LowerQualityQualityMaxCheckControl.GetId(),self.MP3LowerQualityQualityMaxEnable)

		self.MP3LowerQualityBitratePanel=wxPanel(self.MP3LowerQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3LowerQualityBitrateMode=wxRadioBox(self.MP3LowerQualityBitratePanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3LowerQualityBitrateMode.SetStringSelection(MP3LowerQualityBitrateModeString)
		wxStaticText(self.MP3LowerQualityBitratePanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3LowerQualityBitratePanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3LowerQualityBitratePanel,-1,'Poor',wxPoint(180,280))
		self.MP3LowerQualityBitrateAcousticControl=wxSlider(self.MP3LowerQualityBitratePanel, wxNewId(), MP3LowerQualityBitrateAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3LowerQualityBitratePanel,-1,'Bitrate:',wxPoint(0,5))
		wxStaticText(self.MP3LowerQualityBitratePanel,-1,'kbps',wxPoint(150,5))
		self.MP3LowerQualityBitrateControl=wxComboBox(self.MP3LowerQualityBitratePanel,wxNewId(),MP3LowerQualityBitrateValue,wxPoint(50, 0),wxSize(95, -1),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'])
		self.MP3LowerQualityBitrateControl.SetEditable(0)

		self.MP3LowerQualityABRPanel=wxPanel(self.MP3LowerQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3LowerQualityABRMode=wxRadioBox(self.MP3LowerQualityABRPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3LowerQualityABRMode.SetStringSelection(MP3LowerQualityABRModeString)
		wxStaticText(self.MP3LowerQualityABRPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3LowerQualityABRPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3LowerQualityABRPanel,-1,'Poor',wxPoint(180,280))
		self.MP3LowerQualityABRAcousticControl=wxSlider(self.MP3LowerQualityABRPanel, wxNewId(), MP3LowerQualityABRAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3LowerQualityABRPanel,-1,'ABR nominal bitrate:',wxPoint(0,0))
		wxStaticText(self.MP3LowerQualityABRPanel,-1,'kbps',wxPoint(140,50))
		self.MP3LowerQualityABRValue=wxSlider(self.MP3LowerQualityABRPanel,wxNewId(),MP3LowerQualityABRSliderValue,32,320,wxPoint(10,30),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)

		EVT_RADIOBUTTON(self.MP3LowerQualityQualityButton,self.MP3LowerQualityQualityButton.GetId(),self.ShowMP3LowerQualityQuality)
		EVT_RADIOBUTTON(self.MP3LowerQualityBitrateButton,self.MP3LowerQualityBitrateButton.GetId(),self.ShowMP3LowerQualityBitrate)
		EVT_RADIOBUTTON(self.MP3LowerQualityAverageButton,self.MP3LowerQualityAverageButton.GetId(),self.ShowMP3LowerQualityABR)
		if MP3LowerQualityWhichType=='VBR':
			self.MP3LowerQualityQualityButton.SetValue(1)
			self.MP3LowerQualityBitrateButton.SetValue(0)
			self.MP3LowerQualityAverageButton.SetValue(0)
			self.ShowMP3LowerQualityQuality('')
		if MP3LowerQualityWhichType=='CBR':
			self.MP3LowerQualityQualityButton.SetValue(0)
			self.MP3LowerQualityBitrateButton.SetValue(1)
			self.MP3LowerQualityAverageButton.SetValue(0)
			self.ShowMP3LowerQualityBitrate('')
		if MP3LowerQualityWhichType=='ABR':
			self.MP3LowerQualityQualityButton.SetValue(0)
			self.MP3LowerQualityBitrateButton.SetValue(0)
			self.MP3LowerQualityAverageButton.SetValue(1)
			self.ShowMP3LowerQualityABR('')
#----------
#----------
		self.MP3MediumQuality=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3MediumQualityUpperPanel=wxPanel(self.MP3MediumQuality,wxNewId(),wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3MediumQualityQualityButton=wxRadioButton(self.MP3MediumQualityUpperPanel,wxNewId(),'VBR',wxPoint(50,0),style=wxRB_GROUP)
		self.MP3MediumQualityBitrateButton=wxRadioButton(self.MP3MediumQualityUpperPanel,wxNewId(),'CBR',wxPoint(110,0))
		self.MP3MediumQualityAverageButton=wxRadioButton(self.MP3MediumQualityUpperPanel,wxNewId(),'ABR',wxPoint(170,0))
		self.MP3MediumQualityQualityPanel=wxPanel(self.MP3MediumQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3MediumQualityQualityMode=wxRadioBox(self.MP3MediumQualityQualityPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3MediumQualityQualityMode.SetStringSelection(MP3MediumQualityQualityModeString)
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'Poor',wxPoint(180,280))
		self.MP3MediumQualityQualityAcousticControl=wxSlider(self.MP3MediumQualityQualityPanel, wxNewId(), MP3MediumQualityQualityAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		self.MP3MediumQualityQualityType=wxRadioBox(self.MP3MediumQualityQualityPanel,wxNewId(), "VBR type",wxPoint(1,1),wxSize(220,50),['new','old'], 2, wxRA_SPECIFY_COLS)
		self.MP3MediumQualityQualityType.SetStringSelection(MP3MediumQualityQualityTypeValue)
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'VBR quality setting:',wxPoint(1,54))
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'High',wxPoint(10,85))
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'Poor',wxPoint(165,85))
		self.MP3MediumQualityQualityControl=wxSlider(self.MP3MediumQualityQualityPanel, wxNewId(),MP3MediumQualityQualityValue , 0, 9, wxPoint(40, 67),wxSize(120, 10),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'Allowed bitrate (use with caution!):',wxPoint(1,125))
		self.MP3MediumQualityQualityMinCheckControl=wxCheckBox(self.MP3MediumQualityQualityPanel, wxNewId(),'Min',wxPoint(10,150))
		self.MP3MediumQualityQualityMinCheckControl.SetValue(MP3MediumQualityQualityMinCheckControlStatus)
		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'kbps',wxPoint(135,155))
  		self.MP3MediumQualityQualityMinValue=wxComboBox(self.MP3MediumQualityQualityPanel,wxNewId(),MP3MediumQualityQualityMinQualityValue,wxPoint(60,150),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
  		self.MP3MediumQualityQualityMinValue.SetEditable(0)
		self.MP3MediumQualityQualityMinValue.Enable(MP3MediumQualityQualityMinCheckControlStatus)
  		wxStaticText(self.MP3MediumQualityQualityPanel,-1,'kbps',wxPoint(135,185))
		self.MP3MediumQualityQualityMaxCheckControl=wxCheckBox(self.MP3MediumQualityQualityPanel, wxNewId(),'Max',wxPoint(10,180))
  		self.MP3MediumQualityQualityMaxValue=wxComboBox(self.MP3MediumQualityQualityPanel,wxNewId(),MP3MediumQualityQualityMaxQualityValue,wxPoint(60,180),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
 		self.MP3MediumQualityQualityEnforceMinControl=wxCheckBox(self.MP3MediumQualityQualityPanel, wxNewId(),'Enforce minimal bitrate',wxPoint(10,200))
  		self.MP3MediumQualityQualityMaxCheckControl.SetValue(MP3MediumQualityQualityMaxCheckControlStatus)
 		self.MP3MediumQualityQualityMaxValue.SetEditable(0)
 		self.MP3MediumQualityQualityMaxValue.Enable(MP3MediumQualityQualityMaxCheckControlStatus)
 		self.MP3MediumQualityQualityEnforceMinControl.SetValue(MP3MediumQualityQualityEnforceMinStatus)
 		self.MP3MediumQualityQualityEnforceMinControl.Enable(MP3MediumQualityQualityMinCheckControlStatus)
		EVT_CHECKBOX(self.MP3MediumQualityQualityMinCheckControl,self.MP3MediumQualityQualityMinCheckControl.GetId(),self.MP3MediumQualityQualityMinEnable)
		EVT_CHECKBOX(self.MP3MediumQualityQualityMaxCheckControl,self.MP3MediumQualityQualityMaxCheckControl.GetId(),self.MP3MediumQualityQualityMaxEnable)

		self.MP3MediumQualityBitratePanel=wxPanel(self.MP3MediumQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3MediumQualityBitrateMode=wxRadioBox(self.MP3MediumQualityBitratePanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3MediumQualityBitrateMode.SetStringSelection(MP3MediumQualityBitrateModeString)
		wxStaticText(self.MP3MediumQualityBitratePanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3MediumQualityBitratePanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3MediumQualityBitratePanel,-1,'Poor',wxPoint(180,280))
		self.MP3MediumQualityBitrateAcousticControl=wxSlider(self.MP3MediumQualityBitratePanel, wxNewId(), MP3MediumQualityBitrateAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3MediumQualityBitratePanel,-1,'Bitrate:',wxPoint(0,5))
		wxStaticText(self.MP3MediumQualityBitratePanel,-1,'kbps',wxPoint(150,5))
		self.MP3MediumQualityBitrateControl=wxComboBox(self.MP3MediumQualityBitratePanel,wxNewId(),MP3MediumQualityBitrateValue,wxPoint(50, 0),wxSize(95, -1),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'])
		self.MP3MediumQualityBitrateControl.SetEditable(0)

		self.MP3MediumQualityABRPanel=wxPanel(self.MP3MediumQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3MediumQualityABRMode=wxRadioBox(self.MP3MediumQualityABRPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3MediumQualityABRMode.SetStringSelection(MP3MediumQualityABRModeString)
		wxStaticText(self.MP3MediumQualityABRPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3MediumQualityABRPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3MediumQualityABRPanel,-1,'Poor',wxPoint(180,280))
		self.MP3MediumQualityABRAcousticControl=wxSlider(self.MP3MediumQualityABRPanel, wxNewId(), MP3MediumQualityABRAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3MediumQualityABRPanel,-1,'ABR nominal bitrate:',wxPoint(0,0))
		wxStaticText(self.MP3MediumQualityABRPanel,-1,'kbps',wxPoint(140,50))
		self.MP3MediumQualityABRValue=wxSlider(self.MP3MediumQualityABRPanel,wxNewId(),MP3MediumQualityABRSliderValue,32,320,wxPoint(10,30),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)

		EVT_RADIOBUTTON(self.MP3MediumQualityQualityButton,self.MP3MediumQualityQualityButton.GetId(),self.ShowMP3MediumQualityQuality)
		EVT_RADIOBUTTON(self.MP3MediumQualityBitrateButton,self.MP3MediumQualityBitrateButton.GetId(),self.ShowMP3MediumQualityBitrate)
		EVT_RADIOBUTTON(self.MP3MediumQualityAverageButton,self.MP3MediumQualityAverageButton.GetId(),self.ShowMP3MediumQualityABR)
		if MP3MediumQualityWhichType=='VBR':
			self.MP3MediumQualityQualityButton.SetValue(1)
			self.MP3MediumQualityBitrateButton.SetValue(0)
			self.MP3MediumQualityAverageButton.SetValue(0)
			self.ShowMP3MediumQualityQuality('')
		if MP3MediumQualityWhichType=='CBR':
			self.MP3MediumQualityQualityButton.SetValue(0)
			self.MP3MediumQualityBitrateButton.SetValue(1)
			self.MP3MediumQualityAverageButton.SetValue(0)
			self.ShowMP3MediumQualityBitrate('')
		if MP3MediumQualityWhichType=='ABR':
			self.MP3MediumQualityQualityButton.SetValue(0)
			self.MP3MediumQualityBitrateButton.SetValue(0)
			self.MP3MediumQualityAverageButton.SetValue(1)
			self.ShowMP3MediumQualityABR('')

#----------
#----------
		self.MP3HigherQuality=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3HigherQualityUpperPanel=wxPanel(self.MP3HigherQuality,wxNewId(),wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3HigherQualityQualityButton=wxRadioButton(self.MP3HigherQualityUpperPanel,wxNewId(),'VBR',wxPoint(50,0),style=wxRB_GROUP)
		self.MP3HigherQualityBitrateButton=wxRadioButton(self.MP3HigherQualityUpperPanel,wxNewId(),'CBR',wxPoint(110,0))
		self.MP3HigherQualityAverageButton=wxRadioButton(self.MP3HigherQualityUpperPanel,wxNewId(),'ABR',wxPoint(170,0))
		self.MP3HigherQualityQualityPanel=wxPanel(self.MP3HigherQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3HigherQualityQualityMode=wxRadioBox(self.MP3HigherQualityQualityPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3HigherQualityQualityMode.SetStringSelection(MP3HigherQualityQualityModeString)
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'Poor',wxPoint(180,280))
		self.MP3HigherQualityQualityAcousticControl=wxSlider(self.MP3HigherQualityQualityPanel, wxNewId(), MP3HigherQualityQualityAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		self.MP3HigherQualityQualityType=wxRadioBox(self.MP3HigherQualityQualityPanel,wxNewId(), "VBR type",wxPoint(1,1),wxSize(220,50),['new','old'], 2, wxRA_SPECIFY_COLS)
		self.MP3HigherQualityQualityType.SetStringSelection(MP3HigherQualityQualityTypeValue)
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'VBR quality setting:',wxPoint(1,54))
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'High',wxPoint(10,85))
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'Poor',wxPoint(165,85))
		self.MP3HigherQualityQualityControl=wxSlider(self.MP3HigherQualityQualityPanel, wxNewId(),MP3HigherQualityQualityValue , 0, 9, wxPoint(40, 67),wxSize(120, 10),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'Allowed bitrate (use with caution!):',wxPoint(1,125))
		self.MP3HigherQualityQualityMinCheckControl=wxCheckBox(self.MP3HigherQualityQualityPanel, wxNewId(),'Min',wxPoint(10,150))
		self.MP3HigherQualityQualityMinCheckControl.SetValue(MP3HigherQualityQualityMinCheckControlStatus)
		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'kbps',wxPoint(135,155))
  		self.MP3HigherQualityQualityMinValue=wxComboBox(self.MP3HigherQualityQualityPanel,wxNewId(),MP3HigherQualityQualityMinQualityValue,wxPoint(60,150),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
  		self.MP3HigherQualityQualityMinValue.SetEditable(0)
		self.MP3HigherQualityQualityMinValue.Enable(MP3HigherQualityQualityMinCheckControlStatus)
  		wxStaticText(self.MP3HigherQualityQualityPanel,-1,'kbps',wxPoint(135,185))
		self.MP3HigherQualityQualityMaxCheckControl=wxCheckBox(self.MP3HigherQualityQualityPanel, wxNewId(),'Max',wxPoint(10,180))
  		self.MP3HigherQualityQualityMaxValue=wxComboBox(self.MP3HigherQualityQualityPanel,wxNewId(),MP3HigherQualityQualityMaxQualityValue,wxPoint(60,180),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
 		self.MP3HigherQualityQualityEnforceMinControl=wxCheckBox(self.MP3HigherQualityQualityPanel, wxNewId(),'Enforce minimal bitrate',wxPoint(10,200))
  		self.MP3HigherQualityQualityMaxCheckControl.SetValue(MP3HigherQualityQualityMaxCheckControlStatus)
 		self.MP3HigherQualityQualityMaxValue.SetEditable(0)
 		self.MP3HigherQualityQualityMaxValue.Enable(MP3HigherQualityQualityMaxCheckControlStatus)
 		self.MP3HigherQualityQualityEnforceMinControl.SetValue(MP3HigherQualityQualityEnforceMinStatus)
 		self.MP3HigherQualityQualityEnforceMinControl.Enable(MP3HigherQualityQualityMinCheckControlStatus)
		EVT_CHECKBOX(self.MP3HigherQualityQualityMinCheckControl,self.MP3HigherQualityQualityMinCheckControl.GetId(),self.MP3HigherQualityQualityMinEnable)
		EVT_CHECKBOX(self.MP3HigherQualityQualityMaxCheckControl,self.MP3HigherQualityQualityMaxCheckControl.GetId(),self.MP3HigherQualityQualityMaxEnable)

		self.MP3HigherQualityBitratePanel=wxPanel(self.MP3HigherQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3HigherQualityBitrateMode=wxRadioBox(self.MP3HigherQualityBitratePanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3HigherQualityBitrateMode.SetStringSelection(MP3HigherQualityBitrateModeString)
		wxStaticText(self.MP3HigherQualityBitratePanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3HigherQualityBitratePanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3HigherQualityBitratePanel,-1,'Poor',wxPoint(180,280))
		self.MP3HigherQualityBitrateAcousticControl=wxSlider(self.MP3HigherQualityBitratePanel, wxNewId(), MP3HigherQualityBitrateAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3HigherQualityBitratePanel,-1,'Bitrate:',wxPoint(0,5))
		wxStaticText(self.MP3HigherQualityBitratePanel,-1,'kbps',wxPoint(150,5))
		self.MP3HigherQualityBitrateControl=wxComboBox(self.MP3HigherQualityBitratePanel,wxNewId(),MP3HigherQualityBitrateValue,wxPoint(50, 0),wxSize(95, -1),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'])
		self.MP3HigherQualityBitrateControl.SetEditable(0)

		self.MP3HigherQualityABRPanel=wxPanel(self.MP3HigherQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3HigherQualityABRMode=wxRadioBox(self.MP3HigherQualityABRPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3HigherQualityABRMode.SetStringSelection(MP3HigherQualityABRModeString)
		wxStaticText(self.MP3HigherQualityABRPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3HigherQualityABRPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3HigherQualityABRPanel,-1,'Poor',wxPoint(180,280))
		self.MP3HigherQualityABRAcousticControl=wxSlider(self.MP3HigherQualityABRPanel, wxNewId(), MP3HigherQualityABRAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3HigherQualityABRPanel,-1,'ABR nominal bitrate:',wxPoint(0,0))
		wxStaticText(self.MP3HigherQualityABRPanel,-1,'kbps',wxPoint(140,50))
		self.MP3HigherQualityABRValue=wxSlider(self.MP3HigherQualityABRPanel,wxNewId(),MP3HigherQualityABRSliderValue,32,320,wxPoint(10,30),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)

		EVT_RADIOBUTTON(self.MP3HigherQualityQualityButton,self.MP3HigherQualityQualityButton.GetId(),self.ShowMP3HigherQualityQuality)
		EVT_RADIOBUTTON(self.MP3HigherQualityBitrateButton,self.MP3HigherQualityBitrateButton.GetId(),self.ShowMP3HigherQualityBitrate)
		EVT_RADIOBUTTON(self.MP3HigherQualityAverageButton,self.MP3HigherQualityAverageButton.GetId(),self.ShowMP3HigherQualityABR)
		if MP3HigherQualityWhichType=='VBR':
			self.MP3HigherQualityQualityButton.SetValue(1)
			self.MP3HigherQualityBitrateButton.SetValue(0)
			self.MP3HigherQualityAverageButton.SetValue(0)
			self.ShowMP3HigherQualityQuality('')
		if MP3HigherQualityWhichType=='CBR':
			self.MP3HigherQualityQualityButton.SetValue(0)
			self.MP3HigherQualityBitrateButton.SetValue(1)
			self.MP3HigherQualityAverageButton.SetValue(0)
			self.ShowMP3HigherQualityBitrate('')
		if MP3HigherQualityWhichType=='ABR':
			self.MP3HigherQualityQualityButton.SetValue(0)
			self.MP3HigherQualityBitrateButton.SetValue(0)
			self.MP3HigherQualityAverageButton.SetValue(1)
			self.ShowMP3HigherQualityABR('')

#----------
#----------
		self.MP3HighQuality=wxPanel(self.ToMP3,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.MP3HighQualityUpperPanel=wxPanel(self.MP3HighQuality,wxNewId(),wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.MP3HighQualityQualityButton=wxRadioButton(self.MP3HighQualityUpperPanel,wxNewId(),'VBR',wxPoint(50,0),style=wxRB_GROUP)
		self.MP3HighQualityBitrateButton=wxRadioButton(self.MP3HighQualityUpperPanel,wxNewId(),'CBR',wxPoint(110,0))
		self.MP3HighQualityAverageButton=wxRadioButton(self.MP3HighQualityUpperPanel,wxNewId(),'ABR',wxPoint(170,0))
		self.MP3HighQualityQualityPanel=wxPanel(self.MP3HighQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3HighQualityQualityMode=wxRadioBox(self.MP3HighQualityQualityPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3HighQualityQualityMode.SetStringSelection(MP3HighQualityQualityModeString)
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'Poor',wxPoint(180,280))
		self.MP3HighQualityQualityAcousticControl=wxSlider(self.MP3HighQualityQualityPanel, wxNewId(), MP3HighQualityQualityAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		self.MP3HighQualityQualityType=wxRadioBox(self.MP3HighQualityQualityPanel,wxNewId(), "VBR type",wxPoint(1,1),wxSize(220,50),['new','old'], 2, wxRA_SPECIFY_COLS)
		self.MP3HighQualityQualityType.SetStringSelection(MP3HighQualityQualityTypeValue)
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'VBR quality setting:',wxPoint(1,54))
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'High',wxPoint(10,85))
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'Poor',wxPoint(165,85))
		self.MP3HighQualityQualityControl=wxSlider(self.MP3HighQualityQualityPanel, wxNewId(),MP3HighQualityQualityValue , 0, 9, wxPoint(40, 67),wxSize(120, 10),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'Allowed bitrate (use with caution!):',wxPoint(1,125))
		self.MP3HighQualityQualityMinCheckControl=wxCheckBox(self.MP3HighQualityQualityPanel, wxNewId(),'Min',wxPoint(10,150))
		self.MP3HighQualityQualityMinCheckControl.SetValue(MP3HighQualityQualityMinCheckControlStatus)
		wxStaticText(self.MP3HighQualityQualityPanel,-1,'kbps',wxPoint(135,155))
  		self.MP3HighQualityQualityMinValue=wxComboBox(self.MP3HighQualityQualityPanel,wxNewId(),MP3HighQualityQualityMinQualityValue,wxPoint(60,150),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
  		self.MP3HighQualityQualityMinValue.SetEditable(0)
		self.MP3HighQualityQualityMinValue.Enable(MP3HighQualityQualityMinCheckControlStatus)
  		wxStaticText(self.MP3HighQualityQualityPanel,-1,'kbps',wxPoint(135,185))
		self.MP3HighQualityQualityMaxCheckControl=wxCheckBox(self.MP3HighQualityQualityPanel, wxNewId(),'Max',wxPoint(10,180))
  		self.MP3HighQualityQualityMaxValue=wxComboBox(self.MP3HighQualityQualityPanel,wxNewId(),MP3HighQualityQualityMaxQualityValue,wxPoint(60,180),wxSize(70,20),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'], style=wxCB_DROPDOWN)
 		self.MP3HighQualityQualityEnforceMinControl=wxCheckBox(self.MP3HighQualityQualityPanel, wxNewId(),'Enforce minimal bitrate',wxPoint(10,200))
  		self.MP3HighQualityQualityMaxCheckControl.SetValue(MP3HighQualityQualityMaxCheckControlStatus)
 		self.MP3HighQualityQualityMaxValue.SetEditable(0)
 		self.MP3HighQualityQualityMaxValue.Enable(MP3HighQualityQualityMaxCheckControlStatus)
 		self.MP3HighQualityQualityEnforceMinControl.SetValue(MP3HighQualityQualityEnforceMinStatus)
 		self.MP3HighQualityQualityEnforceMinControl.Enable(MP3HighQualityQualityMinCheckControlStatus)
		EVT_CHECKBOX(self.MP3HighQualityQualityMinCheckControl,self.MP3HighQualityQualityMinCheckControl.GetId(),self.MP3HighQualityQualityMinEnable)
		EVT_CHECKBOX(self.MP3HighQualityQualityMaxCheckControl,self.MP3HighQualityQualityMaxCheckControl.GetId(),self.MP3HighQualityQualityMaxEnable)

		self.MP3HighQualityBitratePanel=wxPanel(self.MP3HighQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3HighQualityBitrateMode=wxRadioBox(self.MP3HighQualityBitratePanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3HighQualityBitrateMode.SetStringSelection(MP3HighQualityBitrateModeString)
		wxStaticText(self.MP3HighQualityBitratePanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3HighQualityBitratePanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3HighQualityBitratePanel,-1,'Poor',wxPoint(180,280))
		self.MP3HighQualityBitrateAcousticControl=wxSlider(self.MP3HighQualityBitratePanel, wxNewId(), MP3HighQualityBitrateAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3HighQualityBitratePanel,-1,'Bitrate:',wxPoint(0,5))
		wxStaticText(self.MP3HighQualityBitratePanel,-1,'kbps',wxPoint(150,5))
		self.MP3HighQualityBitrateControl=wxComboBox(self.MP3HighQualityBitratePanel,wxNewId(),MP3HighQualityBitrateValue,wxPoint(50, 0),wxSize(95, -1),['32','40','48','56','64','80','96','112','128','160','192','224','256','320'])
		self.MP3HighQualityBitrateControl.SetEditable(0)

		self.MP3HighQualityABRPanel=wxPanel(self.MP3HighQuality,wxNewId(),wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.MP3HighQualityABRMode=wxRadioBox(self.MP3HighQualityABRPanel,wxNewId(), "Mode:",wxPoint(1,330),wxSize(-1,-1),['Stereo','Joint-Stereo','Mono'], 3, wxRA_SPECIFY_COLS)
		self.MP3HighQualityABRMode.SetStringSelection(MP3HighQualityABRModeString)
		wxStaticText(self.MP3HighQualityABRPanel,-1,'Acoustic algorithm quality :',wxPoint(1,245))
		wxStaticText(self.MP3HighQualityABRPanel,-1,'High',wxPoint(20,280))
		wxStaticText(self.MP3HighQualityABRPanel,-1,'Poor',wxPoint(180,280))
		self.MP3HighQualityABRAcousticControl=wxSlider(self.MP3HighQualityABRPanel, wxNewId(), MP3HighQualityABRAcoustic, 0, 9, wxPoint(50, 260),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)
		wxStaticText(self.MP3HighQualityABRPanel,-1,'ABR nominal bitrate:',wxPoint(0,0))
		wxStaticText(self.MP3HighQualityABRPanel,-1,'kbps',wxPoint(140,50))
		self.MP3HighQualityABRValue=wxSlider(self.MP3HighQualityABRPanel,wxNewId(),MP3HighQualityABRSliderValue,32,320,wxPoint(10,30),wxSize(120, -1),wxSL_HORIZONTAL|wxSL_LABELS)

		EVT_RADIOBUTTON(self.MP3HighQualityQualityButton,self.MP3HighQualityQualityButton.GetId(),self.ShowMP3HighQualityQuality)
		EVT_RADIOBUTTON(self.MP3HighQualityBitrateButton,self.MP3HighQualityBitrateButton.GetId(),self.ShowMP3HighQualityBitrate)
		EVT_RADIOBUTTON(self.MP3HighQualityAverageButton,self.MP3HighQualityAverageButton.GetId(),self.ShowMP3HighQualityABR)
		if MP3HighQualityWhichType=='VBR':
			self.MP3HighQualityQualityButton.SetValue(1)
			self.MP3HighQualityBitrateButton.SetValue(0)
			self.MP3HighQualityAverageButton.SetValue(0)
			self.ShowMP3HighQualityQuality('')
		if MP3HighQualityWhichType=='CBR':
			self.MP3HighQualityQualityButton.SetValue(0)
			self.MP3HighQualityBitrateButton.SetValue(1)
			self.MP3HighQualityAverageButton.SetValue(0)
			self.ShowMP3HighQualityBitrate('')
		if MP3HighQualityWhichType=='ABR':
			self.MP3HighQualityQualityButton.SetValue(0)
			self.MP3HighQualityBitrateButton.SetValue(0)
			self.MP3HighQualityAverageButton.SetValue(1)
			self.ShowMP3HighQualityABR('')

#----------



#----------

		EVT_RADIOBUTTON(self.MP3FromMP3button,self.MP3FromMP3button.GetId(),self.ShowMP3MP3)
		EVT_RADIOBUTTON(self.MP3FromWMAbutton,self.MP3FromWMAbutton.GetId(),self.ShowMP3WMA)
  		EVT_RADIOBUTTON(self.MP3FromOGGbutton,self.MP3FromOGGbutton.GetId(),self.ShowMP3OGG)
 		EVT_RADIOBUTTON(self.MP3LowQualitybutton,self.MP3LowQualitybutton.GetId(),self.ShowMP3LowQuality)
 		EVT_RADIOBUTTON(self.MP3LowerQualitybutton,self.MP3LowerQualitybutton.GetId(),self.ShowMP3LowerQuality)
 		EVT_RADIOBUTTON(self.MP3MediumQualitybutton,self.MP3MediumQualitybutton.GetId(),self.ShowMP3MediumQuality)
 		EVT_RADIOBUTTON(self.MP3HigherQualitybutton,self.MP3HigherQualitybutton.GetId(),self.ShowMP3HigherQuality)
 		EVT_RADIOBUTTON(self.MP3HighQualitybutton,self.MP3HighQualitybutton.GetId(),self.ShowMP3HighQuality)
		self.ShowMP3MP3('')

#-------

	def MP3LowQualityQualityMinEnable(self,event):
		self.MP3LowQualityQualityMinValue.Enable(event.Checked())
		if event.Checked()==0:
			self.MP3LowQualityQualityEnforceMinControl.SetValue(0)
		self.MP3LowQualityQualityEnforceMinControl.Enable(event.Checked())
	def MP3LowQualityQualityMaxEnable(self,event):
		self.MP3LowQualityQualityMaxValue.Enable(event.Checked())
	def ShowMP3LowQualityQuality(self,junk):
		self.MP3LowQualityQualityPanel.Show(1)
		self.MP3LowQualityBitratePanel.Show(0)
		self.MP3LowQualityABRPanel.Show(0)
		global MP3LowQualityWhichType
		MP3LowQualityWhichType='VBR'
	def ShowMP3LowQualityBitrate(self,junk):
		self.MP3LowQualityQualityPanel.Show(0)
		self.MP3LowQualityBitratePanel.Show(1)
		self.MP3LowQualityABRPanel.Show(0)
		global MP3LowQualityWhichType
		MP3LowQualityWhichType='CBR'
	def ShowMP3LowQualityABR(self,junk):
		self.MP3LowQualityQualityPanel.Show(0)
		self.MP3LowQualityBitratePanel.Show(0)
		self.MP3LowQualityABRPanel.Show(1)
		global MP3LowQualityWhichType
		MP3LowQualityWhichType='ABR'

#--------
#-------
	def MP3LowerQualityQualityMinEnable(self,event):
		self.MP3LowerQualityQualityMinValue.Enable(event.Checked())
		if event.Checked()==0:
			self.MP3LowerQualityQualityEnforceMinControl.SetValue(0)
		self.MP3LowerQualityQualityEnforceMinControl.Enable(event.Checked())
	def MP3LowerQualityQualityMaxEnable(self,event):
		self.MP3LowerQualityQualityMaxValue.Enable(event.Checked())
	def ShowMP3LowerQualityQuality(self,junk):
		self.MP3LowerQualityQualityPanel.Show(1)
		self.MP3LowerQualityBitratePanel.Show(0)
		self.MP3LowerQualityABRPanel.Show(0)
		global MP3LowerQualityWhichType
		MP3LowerQualityWhichType='VBR'
	def ShowMP3LowerQualityBitrate(self,junk):
		self.MP3LowerQualityQualityPanel.Show(0)
		self.MP3LowerQualityBitratePanel.Show(1)
		self.MP3LowerQualityABRPanel.Show(0)
		global MP3LowerQualityWhichType
		MP3LowerQualityWhichType='CBR'
	def ShowMP3LowerQualityABR(self,junk):
		self.MP3LowerQualityQualityPanel.Show(0)
		self.MP3LowerQualityBitratePanel.Show(0)
		self.MP3LowerQualityABRPanel.Show(1)
		global MP3LowerQualityWhichType
		MP3LowerQualityWhichType='ABR'

#--------
#-------
	def MP3MediumQualityQualityMinEnable(self,event):
		self.MP3MediumQualityQualityMinValue.Enable(event.Checked())
		if event.Checked()==0:
			self.MP3MediumQualityQualityEnforceMinControl.SetValue(0)
		self.MP3MediumQualityQualityEnforceMinControl.Enable(event.Checked())
	def MP3MediumQualityQualityMaxEnable(self,event):
		self.MP3MediumQualityQualityMaxValue.Enable(event.Checked())
	def ShowMP3MediumQualityQuality(self,junk):
		self.MP3MediumQualityQualityPanel.Show(1)
		self.MP3MediumQualityBitratePanel.Show(0)
		self.MP3MediumQualityABRPanel.Show(0)
		global MP3MediumQualityWhichType
		MP3MediumQualityWhichType='VBR'
	def ShowMP3MediumQualityBitrate(self,junk):
		self.MP3MediumQualityQualityPanel.Show(0)
		self.MP3MediumQualityBitratePanel.Show(1)
		self.MP3MediumQualityABRPanel.Show(0)
		global MP3MediumQualityWhichType
		MP3MediumQualityWhichType='CBR'
	def ShowMP3MediumQualityABR(self,junk):
		self.MP3MediumQualityQualityPanel.Show(0)
		self.MP3MediumQualityBitratePanel.Show(0)
		self.MP3MediumQualityABRPanel.Show(1)
		global MP3MediumQualityWhichType
		MP3MediumQualityWhichType='ABR'

#--------
#-------
	def MP3HigherQualityQualityMinEnable(self,event):
		self.MP3HigherQualityQualityMinValue.Enable(event.Checked())
		if event.Checked()==0:
			self.MP3HigherQualityQualityEnforceMinControl.SetValue(0)
		self.MP3HigherQualityQualityEnforceMinControl.Enable(event.Checked())
	def MP3HigherQualityQualityMaxEnable(self,event):
		self.MP3HigherQualityQualityMaxValue.Enable(event.Checked())
	def ShowMP3HigherQualityQuality(self,junk):
		self.MP3HigherQualityQualityPanel.Show(1)
		self.MP3HigherQualityBitratePanel.Show(0)
		self.MP3HigherQualityABRPanel.Show(0)
		global MP3HigherQualityWhichType
		MP3HigherQualityWhichType='VBR'
	def ShowMP3HigherQualityBitrate(self,junk):
		self.MP3HigherQualityQualityPanel.Show(0)
		self.MP3HigherQualityBitratePanel.Show(1)
		self.MP3HigherQualityABRPanel.Show(0)
		global MP3HigherQualityWhichType
		MP3HigherQualityWhichType='CBR'
	def ShowMP3HigherQualityABR(self,junk):
		self.MP3HigherQualityQualityPanel.Show(0)
		self.MP3HigherQualityBitratePanel.Show(0)
		self.MP3HigherQualityABRPanel.Show(1)
		global MP3HigherQualityWhichType
		MP3HigherQualityWhichType='ABR'

#--------
#-------
	def MP3HighQualityQualityMinEnable(self,event):
		self.MP3HighQualityQualityMinValue.Enable(event.Checked())
		if event.Checked()==0:
			self.MP3HighQualityQualityEnforceMinControl.SetValue(0)
		self.MP3HighQualityQualityEnforceMinControl.Enable(event.Checked())
	def MP3HighQualityQualityMaxEnable(self,event):
		self.MP3HighQualityQualityMaxValue.Enable(event.Checked())
	def ShowMP3HighQualityQuality(self,junk):
		self.MP3HighQualityQualityPanel.Show(1)
		self.MP3HighQualityBitratePanel.Show(0)
		self.MP3HighQualityABRPanel.Show(0)
		global MP3HighQualityWhichType
		MP3HighQualityWhichType='VBR'
	def ShowMP3HighQualityBitrate(self,junk):
		self.MP3HighQualityQualityPanel.Show(0)
		self.MP3HighQualityBitratePanel.Show(1)
		self.MP3HighQualityABRPanel.Show(0)
		global MP3HighQualityWhichType
		MP3HighQualityWhichType='CBR'
	def ShowMP3HighQualityABR(self,junk):
		self.MP3HighQualityQualityPanel.Show(0)
		self.MP3HighQualityBitratePanel.Show(0)
		self.MP3HighQualityABRPanel.Show(1)
		global MP3HighQualityWhichType
		MP3HighQualityWhichType='ABR'
#--------

	def ShowMP3MP3(self,junk):
		self.HideAllMP3()
		self.MP3FromMP3MainPanel.Show(1)
	def ShowMP3WMA(self,junk):
		self.HideAllMP3()
		self.MP3FromWMAMainPanel.Show(1)
	def ShowMP3OGG(self,junk):
		self.HideAllMP3()
		self.MP3FromOGGMainPanel.Show(1)
	def ShowMP3LowQuality(self,junk):
		self.HideAllMP3()
		self.MP3LowQuality.Show(1)
	def ShowMP3LowerQuality(self,junk):
		self.HideAllMP3()
		self.MP3LowerQuality.Show(1)
	def ShowMP3MediumQuality(self,junk):
		self.HideAllMP3()
		self.MP3MediumQuality.Show(1)
	def ShowMP3HigherQuality(self,junk):
		self.HideAllMP3()
		self.MP3HigherQuality.Show(1)
	def ShowMP3HighQuality(self,junk):
		self.HideAllMP3()
		self.MP3HighQuality.Show(1)

	def HideAllMP3(self):
# It's ugly code, but without hiding all other panels, panel we want to have
# shown might not show. At least it didn't work out on my Gentoo box -
# KDE 3.1.5, wxPython 2.4.1.2
		self.MP3FromMP3MainPanel.Show(0)
		self.MP3FromWMAMainPanel.Show(0)
		self.MP3FromOGGMainPanel.Show(0)
 		self.MP3LowQuality.Show(0)
 		self.MP3LowerQuality.Show(0)
 		self.MP3MediumQuality.Show(0)
 		self.MP3HigherQuality.Show(0)
 		self.MP3HighQuality.Show(0)
#----
	def OggPageFill(self):
		self.OggFromMP3button=wxRadioButton(self.ToOgg,wxNewId(),'From MP3',wxPoint(1,40),style=wxRB_GROUP)
		self.OggFromWMAbutton=wxRadioButton(self.ToOgg,wxNewId(),'From WMA',wxPoint(1,70))
		self.OggFromOGGbutton=wxRadioButton(self.ToOgg,wxNewId(),'From OGG',wxPoint(1,100))
		self.OggLowQualitybutton=wxRadioButton(self.ToOgg,wxNewId(),'Low Quality',wxPoint(1,160))
		self.OggLowerQualitybutton=wxRadioButton(self.ToOgg,wxNewId(),'Lower Quality',wxPoint(1,190))
		self.OggMediumQualitybutton=wxRadioButton(self.ToOgg,wxNewId(),'Medium Quality',wxPoint(1,220))
		self.OggHigherQualitybutton=wxRadioButton(self.ToOgg,wxNewId(),'Higher Quality',wxPoint(1,250))
		self.OggHighQualitybutton=wxRadioButton(self.ToOgg,wxNewId(),'High Quality',wxPoint(1,280))
		self.OggOkayButton=wxButton(self.ToOgg,wxNewId(),'Save',wxPoint(10,350))

#----------
		self.OggFromMP3MainPanel=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggFromMP3TextPanel=wxPanel(self.OggFromMP3MainPanel,-1,wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.OggFromMP3=wxPanel(self.OggFromMP3MainPanel,-1,wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.OggFromMP3HeadingText=wxStaticText(self.OggFromMP3TextPanel,-1,'From MP3 to Ogg:',wxPoint(10,10))
		self.OggFromMP3HeadingText.SetFont(wxFont(18, wxSWISS, wxNORMAL, wxNORMAL))
		self.OggFromMP3LowQualityText=wxStaticText(self.OggFromMP3,-1,'Low quality',wxPoint(10,10))
		self.OggFromMP3LowQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromMP3,-1,'maximal:',wxPoint(180,10))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,10))
		self.OggFromMP3LowQualityValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,7),wxSize(50,20))
		self.OggFromMP3LowQualityValue.SetRange(8,320)
		self.OggFromMP3LowQualityValue.SetValue(OggFromMp3LowValue)
###
		self.OggFromMP3LowerQualityText=wxStaticText(self.OggFromMP3,-1,'Lower quality range',wxPoint(10,60))
		self.OggFromMP3LowerQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromMP3,-1,'minimum:',wxPoint(180,60))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,60))
		self.OggFromMP3LowerMinValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,57),wxSize(50,20))
		self.OggFromMP3LowerMinValue.SetRange(8,320)
		self.OggFromMP3LowerMinValue.SetValue(OggFromMp3LowerMinValue)
		wxStaticText(self.OggFromMP3,-1,'maximum:',wxPoint(180,80))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,80))
		self.OggFromMP3LowerMaxValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,77),wxSize(50,20))
		self.OggFromMP3LowerMaxValue.SetRange(8,320)
		self.OggFromMP3LowerMaxValue.SetValue(OggFromMp3LowerMaxValue)
###
		self.OggFromMP3MediumQualityText=wxStaticText(self.OggFromMP3,-1,'Medium quality range',wxPoint(10,110))
		self.OggFromMP3MediumQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromMP3,-1,'minimum:',wxPoint(180,110))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,110))
		self.OggFromMP3MediumMinValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,107),wxSize(50,20))
		self.OggFromMP3MediumMinValue.SetRange(8,320)
		self.OggFromMP3MediumMinValue.SetValue(OggFromMp3MediumMinValue)
		wxStaticText(self.OggFromMP3,-1,'maximum:',wxPoint(180,130))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,130))
		self.OggFromMP3MediumMaxValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,127),wxSize(50,20))
		self.OggFromMP3MediumMaxValue.SetRange(8,320)
		self.OggFromMP3MediumMaxValue.SetValue(OggFromMp3MediumMaxValue)
###
		self.OggFromMP3HigherQualityText=wxStaticText(self.OggFromMP3,-1,'Higher quality range',wxPoint(10,160))
		self.OggFromMP3HigherQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromMP3,-1,'minimum:',wxPoint(180,160))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,160))
		self.OggFromMP3HigherMinValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,157),wxSize(50,20))
		self.OggFromMP3HigherMinValue.SetRange(8,320)
		self.OggFromMP3HigherMinValue.SetValue(OggFromMp3HigherMinValue)
		wxStaticText(self.OggFromMP3,-1,'maximum:',wxPoint(180,180))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,180))
		self.OggFromMP3HigherMaxValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,177),wxSize(50,20))
		self.OggFromMP3HigherMaxValue.SetRange(8,320)
		self.OggFromMP3HigherMaxValue.SetValue(OggFromMp3HigherMaxValue)
###
		self.OggFromMP3HighQualityText=wxStaticText(self.OggFromMP3,-1,'High quality',wxPoint(10,210))
		self.OggFromMP3HighQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromMP3,-1,'at least:',wxPoint(180,210))
		wxStaticText(self.OggFromMP3,-1,'kbps',wxPoint(335,210))
		self.OggFromMP3HighValue=wxSpinCtrl(self.OggFromMP3,wxNewId(),'',wxPoint(280,207),wxSize(50,20))
		self.OggFromMP3HighValue.SetRange(8,320)
		self.OggFromMP3HighValue.SetValue(OggFromMp3HighValue)
#----------
#----------
		self.OggFromWMAMainPanel=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggFromWMATextPanel=wxPanel(self.OggFromWMAMainPanel,-1,wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.OggFromWMA=wxPanel(self.OggFromWMAMainPanel,-1,wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.OggFromWMAHeadingText=wxStaticText(self.OggFromWMATextPanel,-1,'From WMA to Ogg:',wxPoint(10,10))
		self.OggFromWMAHeadingText.SetFont(wxFont(18, wxSWISS, wxNORMAL, wxNORMAL))
		self.OggFromWMALowQualityText=wxStaticText(self.OggFromWMA,-1,'Low quality',wxPoint(10,10))
		self.OggFromWMALowQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromWMA,-1,'maximal:',wxPoint(180,10))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,10))
		self.OggFromWMALowValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,7),wxSize(50,20))
		self.OggFromWMALowValue.SetRange(8,320)
		self.OggFromWMALowValue.SetValue(OggFromWMALowValue)
###
		self.OggFromWMALowerQualityText=wxStaticText(self.OggFromWMA,-1,'Lower quality range',wxPoint(10,60))
		self.OggFromWMALowerQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromWMA,-1,'minimum:',wxPoint(180,60))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,60))
		self.OggFromWMALowerMinValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,57),wxSize(50,20))
		self.OggFromWMALowerMinValue.SetRange(8,320)
		self.OggFromWMALowerMinValue.SetValue(OggFromWMALowerMinValue)
		wxStaticText(self.OggFromWMA,-1,'maximum:',wxPoint(180,80))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,80))
		self.OggFromWMALowerMaxValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,77),wxSize(50,20))
		self.OggFromWMALowerMaxValue.SetRange(8,320)
		self.OggFromWMALowerMaxValue.SetValue(OggFromWMALowerMaxValue)
###
		self.OggFromWMAMediumQualityText=wxStaticText(self.OggFromWMA,-1,'Medium quality range',wxPoint(10,110))
		self.OggFromWMAMediumQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromWMA,-1,'minimum:',wxPoint(180,110))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,110))
		self.OggFromWMAMediumMinValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,107),wxSize(50,20))
		self.OggFromWMAMediumMinValue.SetRange(8,320)
		self.OggFromWMAMediumMinValue.SetValue(OggFromWMAMediumMinValue)
		wxStaticText(self.OggFromWMA,-1,'maximum:',wxPoint(180,130))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,130))
		self.OggFromWMAMediumMaxValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,127),wxSize(50,20))
		self.OggFromWMAMediumMaxValue.SetRange(8,320)
		self.OggFromWMAMediumMaxValue.SetValue(OggFromWMAMediumMaxValue)
###
		self.OggFromWMAHigherQualityText=wxStaticText(self.OggFromWMA,-1,'Higher quality range',wxPoint(10,160))
		self.OggFromWMAHigherQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromWMA,-1,'minimum:',wxPoint(180,160))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,160))
		self.OggFromWMAHigherMinValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,157),wxSize(50,20))
		self.OggFromWMAHigherMinValue.SetRange(8,320)
		self.OggFromWMAHigherMinValue.SetValue(OggFromWMAHigherMinValue)
		wxStaticText(self.OggFromWMA,-1,'maximum:',wxPoint(180,180))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,180))
		self.OggFromWMAHigherMaxValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,177),wxSize(50,20))
		self.OggFromWMAHigherMaxValue.SetRange(8,320)
		self.OggFromWMAHigherMaxValue.SetValue(OggFromWMAHigherMaxValue)
###
		self.OggFromWMAHighQualityText=wxStaticText(self.OggFromWMA,-1,'High quality',wxPoint(10,210))
		self.OggFromWMAHighQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromWMA,-1,'at least:',wxPoint(180,210))
		wxStaticText(self.OggFromWMA,-1,'kbps',wxPoint(335,210))
		self.OggFromWMAHighValue=wxSpinCtrl(self.OggFromWMA,wxNewId(),'',wxPoint(280,207),wxSize(50,20))
		self.OggFromWMAHighValue.SetRange(8,320)
		self.OggFromWMAHighValue.SetValue(OggFromWMAHighValue)

#----------
#----------
		self.OggFromOGGMainPanel=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggFromOGGTextPanel=wxPanel(self.OggFromOGGMainPanel,-1,wxPoint(0,0),wxSize(470,50),wxNO_BORDER)
		self.OggFromOGG=wxPanel(self.OggFromOGGMainPanel,-1,wxPoint(0,50),wxSize(470,390),wxNO_BORDER)
		self.OggFromOGGHeadingText=wxStaticText(self.OggFromOGGTextPanel,-1,'From Ogg to Ogg:',wxPoint(10,10))
		self.OggFromOGGHeadingText.SetFont(wxFont(18, wxSWISS, wxNORMAL, wxNORMAL))
		self.OggFromOGGLowQualityText=wxStaticText(self.OggFromOGG,-1,'Low quality',wxPoint(10,10))
		self.OggFromOGGLowQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromOGG,-1,'maximal:',wxPoint(180,10))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,10))
		self.OggFromOGGLowValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,7),wxSize(50,20))
		self.OggFromOGGLowValue.SetRange(8,320)
		self.OggFromOGGLowValue.SetValue(OggFromOGGLowValue)
###
		self.OggFromOGGLowerQualityText=wxStaticText(self.OggFromOGG,-1,'Lower quality range',wxPoint(10,60))
		self.OggFromOGGLowerQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromOGG,-1,'minimum:',wxPoint(180,60))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,60))
		self.OggFromOGGLowerMinValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,57),wxSize(50,20))
		self.OggFromOGGLowerMinValue.SetRange(8,320)
		self.OggFromOGGLowerMinValue.SetValue(OggFromOGGLowerMinValue)
		wxStaticText(self.OggFromOGG,-1,'maximum:',wxPoint(180,80))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,80))
		self.OggFromOGGLowerMaxValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,77),wxSize(50,20))
		self.OggFromOGGLowerMaxValue.SetRange(8,320)
		self.OggFromOGGLowerMaxValue.SetValue(OggFromOGGLowerMaxValue)
###
		self.OggFromOGGMediumQualityText=wxStaticText(self.OggFromOGG,-1,'Medium quality range',wxPoint(10,110))
		self.OggFromOGGMediumQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromOGG,-1,'minimum:',wxPoint(180,110))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,110))
		self.OggFromOGGMediumMinValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,107),wxSize(50,20))
		self.OggFromOGGMediumMinValue.SetRange(8,320)
		self.OggFromOGGMediumMinValue.SetValue(OggFromOGGMediumMinValue)
		wxStaticText(self.OggFromOGG,-1,'maximum:',wxPoint(180,130))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,130))
		self.OggFromOGGMediumMaxValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,127),wxSize(50,20))
		self.OggFromOGGMediumMaxValue.SetRange(8,320)
		self.OggFromOGGMediumMaxValue.SetValue(OggFromOGGMediumMaxValue)
###
		self.OggFromOGGHigherQualityText=wxStaticText(self.OggFromOGG,-1,'Higher quality range',wxPoint(10,160))
		self.OggFromOGGHigherQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromOGG,-1,'minimum:',wxPoint(180,160))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,160))
		self.OggFromOGGHigherMinValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,157),wxSize(50,20))
		self.OggFromOGGHigherMinValue.SetRange(8,320)
		self.OggFromOGGHigherMinValue.SetValue(OggFromOGGHigherMinValue)
		wxStaticText(self.OggFromOGG,-1,'maximum:',wxPoint(180,180))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,180))
		self.OggFromOGGHigherMaxValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,177),wxSize(50,20))
		self.OggFromOGGHigherMaxValue.SetRange(8,320)
		self.OggFromOGGHigherMaxValue.SetValue(OggFromOGGHigherMaxValue)
###
		self.OggFromOGGHighQualityText=wxStaticText(self.OggFromOGG,-1,'High quality',wxPoint(10,210))
		self.OggFromOGGHighQualityText.SetFont(wxFont(9, wxBOLD, wxBOLD, wxBOLD))
		wxStaticText(self.OggFromOGG,-1,'at least:',wxPoint(180,210))
		wxStaticText(self.OggFromOGG,-1,'kbps',wxPoint(335,210))
		self.OggFromOGGHighValue=wxSpinCtrl(self.OggFromOGG,wxNewId(),'',wxPoint(280,207),wxSize(50,20))
		self.OggFromOGGHighValue.SetRange(8,320)
		self.OggFromOGGHighValue.SetValue(OggFromOGGHighValue)

#----------
#----------
		self.OggLowQuality=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggLowQualityQualityButton=wxRadioButton(self.OggLowQuality,wxNewId(),'Quality',wxPoint(1,10),style=wxRB_GROUP)
		self.OggLowQualityBitrateButton=wxRadioButton(self.OggLowQuality,wxNewId(),'Bitrate',wxPoint(1,110))
		self.OggLowQualitySizeButton=wxRadioButton(self.OggLowQuality,wxNewId(),'Limits',wxPoint(1,210))
		self.OggLowQualityQualitySliderText=wxStaticText(self.OggLowQuality,-1,'',wxPoint(138,42))
		self.OggLowQualityQualitySlider=wxSlider(self.OggLowQuality,wxNewId(),OggLowQualityQualitySliderValue,-100, 1000,wxPoint(1,40),wxSize(120,20),wxSL_HORIZONTAL)
		self.OggLowQualityQualitySliderMoved('')
		self.OggLowQualityBitrateSlider=wxSlider(self.OggLowQuality,wxNewId(),OggLowQualityBitrateSliderValue,48,500,wxPoint(1,140),wxSize(120,20),wxSL_LABELS)
		self.OggLowQualityText1=wxStaticText(self.OggLowQuality,-1,'kbps',wxPoint(138,156))
		self.OggLowQualityText2=wxStaticText(self.OggLowQuality,-1,'kbps',wxPoint(138,256))
		self.OggLowQualityText3=wxStaticText(self.OggLowQuality,-1,'kbps',wxPoint(138,296))
		self.OggLowQualitySizeMinSlider=wxSlider(self.OggLowQuality,wxNewId(),OggLowQualitySizeMinSliderValue,48,500,wxPoint(1,240),wxSize(120,20),wxSL_LABELS)
		self.OggLowQualitySizeMaxSlider=wxSlider(self.OggLowQuality,wxNewId(),OggLowQualitySizeMaxSliderValue,48,500,wxPoint(1,280),wxSize(120,20),wxSL_LABELS)
		EVT_RADIOBUTTON(self.OggLowQualityQualityButton,self.OggLowQualityQualityButton.GetId(),self.OggLowQualityShowQuality)
		EVT_RADIOBUTTON(self.OggLowQualityBitrateButton,self.OggLowQualityBitrateButton.GetId(),self.OggLowQualityShowBitrate)
		EVT_RADIOBUTTON(self.OggLowQualitySizeButton,self.OggLowQualitySizeButton.GetId(),self.OggLowQualityShowSize)
		EVT_SLIDER(self.OggLowQualityQualitySlider,self.OggLowQualityQualitySlider.GetId(),self.OggLowQualityQualitySliderMoved)
		self.OggLowQualityDisableAll()
		if OggLowWhichChecked=='quality':
			self.OggLowQualityShowQuality('')
			self.OggLowQualityQualityButton.SetValue(1)
			self.OggLowQualityBitrateButton.SetValue(0)
			self.OggLowQualitySizeButton.SetValue(0)
		if OggLowWhichChecked=='bitrate':
			self.OggLowQualityShowBitrate('')
			self.OggLowQualityQualityButton.SetValue(0)
			self.OggLowQualityBitrateButton.SetValue(1)
			self.OggLowQualitySizeButton.SetValue(0)
		if OggLowWhichChecked=='size':
			self.OggLowQualityShowSize('')
			self.OggLowQualityQualityButton.SetValue(0)
			self.OggLowQualityBitrateButton.SetValue(0)
			self.OggLowQualitySizeButton.SetValue(1)
#----------
		self.OggLowerQuality=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggLowerQualityQualityButton=wxRadioButton(self.OggLowerQuality,wxNewId(),'Quality',wxPoint(1,10),style=wxRB_GROUP)
		self.OggLowerQualityBitrateButton=wxRadioButton(self.OggLowerQuality,wxNewId(),'Bitrate',wxPoint(1,110))
		self.OggLowerQualitySizeButton=wxRadioButton(self.OggLowerQuality,wxNewId(),'Limits',wxPoint(1,210))
		self.OggLowerQualityQualitySliderText=wxStaticText(self.OggLowerQuality,-1,'',wxPoint(138,42))
		self.OggLowerQualityQualitySlider=wxSlider(self.OggLowerQuality,wxNewId(),OggLowerQualityQualitySliderValue,-100, 1000,wxPoint(1,40),wxSize(120,20),wxSL_HORIZONTAL)
		self.OggLowerQualityQualitySliderMoved('')
		self.OggLowerQualityBitrateSlider=wxSlider(self.OggLowerQuality,wxNewId(),OggLowerQualityBitrateSliderValue,48,500,wxPoint(1,140),wxSize(120,20),wxSL_LABELS)
		self.OggLowerQualityText1=wxStaticText(self.OggLowerQuality,-1,'kbps',wxPoint(138,156))
		self.OggLowerQualityText2=wxStaticText(self.OggLowerQuality,-1,'kbps',wxPoint(138,256))
		self.OggLowerQualityText3=wxStaticText(self.OggLowerQuality,-1,'kbps',wxPoint(138,296))
		self.OggLowerQualitySizeMinSlider=wxSlider(self.OggLowerQuality,wxNewId(),OggLowerQualitySizeMinSliderValue,48,500,wxPoint(1,240),wxSize(120,20),wxSL_LABELS)
		self.OggLowerQualitySizeMaxSlider=wxSlider(self.OggLowerQuality,wxNewId(),OggLowerQualitySizeMaxSliderValue,48,500,wxPoint(1,280),wxSize(120,20),wxSL_LABELS)
		EVT_RADIOBUTTON(self.OggLowerQualityQualityButton,self.OggLowerQualityQualityButton.GetId(),self.OggLowerQualityShowQuality)
		EVT_RADIOBUTTON(self.OggLowerQualityBitrateButton,self.OggLowerQualityBitrateButton.GetId(),self.OggLowerQualityShowBitrate)
		EVT_RADIOBUTTON(self.OggLowerQualitySizeButton,self.OggLowerQualitySizeButton.GetId(),self.OggLowerQualityShowSize)
		EVT_SLIDER(self.OggLowerQualityQualitySlider,self.OggLowerQualityQualitySlider.GetId(),self.OggLowerQualityQualitySliderMoved)
		self.OggLowerQualityDisableAll()
		if OggLowerWhichChecked=='quality':
			self.OggLowerQualityShowQuality('')
			self.OggLowerQualityQualityButton.SetValue(1)
			self.OggLowerQualityBitrateButton.SetValue(0)
			self.OggLowerQualitySizeButton.SetValue(0)
		if OggLowerWhichChecked=='bitrate':
			self.OggLowerQualityShowBitrate('')
			self.OggLowerQualityQualityButton.SetValue(0)
			self.OggLowerQualityBitrateButton.SetValue(1)
			self.OggLowerQualitySizeButton.SetValue(0)
		if OggLowerWhichChecked=='size':
			self.OggLowerQualityShowSize('')
			self.OggLowerQualityQualityButton.SetValue(0)
			self.OggLowerQualityBitrateButton.SetValue(0)
			self.OggLowerQualitySizeButton.SetValue(1)

#----------
#----------
		self.OggMediumQuality=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggMediumQualityQualityButton=wxRadioButton(self.OggMediumQuality,wxNewId(),'Quality',wxPoint(1,10),style=wxRB_GROUP)
		self.OggMediumQualityBitrateButton=wxRadioButton(self.OggMediumQuality,wxNewId(),'Bitrate',wxPoint(1,110))
		self.OggMediumQualitySizeButton=wxRadioButton(self.OggMediumQuality,wxNewId(),'Limits',wxPoint(1,210))
		self.OggMediumQualityQualitySliderText=wxStaticText(self.OggMediumQuality,-1,'',wxPoint(138,42))
		self.OggMediumQualityQualitySlider=wxSlider(self.OggMediumQuality,wxNewId(),OggMediumQualityQualitySliderValue,-100, 1000,wxPoint(1,40),wxSize(120,20),wxSL_HORIZONTAL)
		self.OggMediumQualityQualitySliderMoved('')
		self.OggMediumQualityBitrateSlider=wxSlider(self.OggMediumQuality,wxNewId(),OggMediumQualityBitrateSliderValue,48,500,wxPoint(1,140),wxSize(120,20),wxSL_LABELS)
		self.OggMediumQualityText1=wxStaticText(self.OggMediumQuality,-1,'kbps',wxPoint(138,156))
		self.OggMediumQualityText2=wxStaticText(self.OggMediumQuality,-1,'kbps',wxPoint(138,256))
		self.OggMediumQualityText3=wxStaticText(self.OggMediumQuality,-1,'kbps',wxPoint(138,296))
		self.OggMediumQualitySizeMinSlider=wxSlider(self.OggMediumQuality,wxNewId(),OggMediumQualitySizeMinSliderValue,48,500,wxPoint(1,240),wxSize(120,20),wxSL_LABELS)
		self.OggMediumQualitySizeMaxSlider=wxSlider(self.OggMediumQuality,wxNewId(),OggMediumQualitySizeMaxSliderValue,48,500,wxPoint(1,280),wxSize(120,20),wxSL_LABELS)
		EVT_RADIOBUTTON(self.OggMediumQualityQualityButton,self.OggMediumQualityQualityButton.GetId(),self.OggMediumQualityShowQuality)
		EVT_RADIOBUTTON(self.OggMediumQualityBitrateButton,self.OggMediumQualityBitrateButton.GetId(),self.OggMediumQualityShowBitrate)
		EVT_RADIOBUTTON(self.OggMediumQualitySizeButton,self.OggMediumQualitySizeButton.GetId(),self.OggMediumQualityShowSize)
		EVT_SLIDER(self.OggMediumQualityQualitySlider,self.OggMediumQualityQualitySlider.GetId(),self.OggMediumQualityQualitySliderMoved)
		self.OggMediumQualityDisableAll()
		if OggMediumWhichChecked=='quality':
			self.OggMediumQualityShowQuality('')
			self.OggMediumQualityQualityButton.SetValue(1)
			self.OggMediumQualityBitrateButton.SetValue(0)
			self.OggMediumQualitySizeButton.SetValue(0)
		if OggMediumWhichChecked=='bitrate':
			self.OggMediumQualityShowBitrate('')
			self.OggMediumQualityQualityButton.SetValue(0)
			self.OggMediumQualityBitrateButton.SetValue(1)
			self.OggMediumQualitySizeButton.SetValue(0)
		if OggMediumWhichChecked=='size':
			self.OggMediumQualityShowSize('')
			self.OggMediumQualityQualityButton.SetValue(0)
			self.OggMediumQualityBitrateButton.SetValue(0)
			self.OggMediumQualitySizeButton.SetValue(1)
#----------
#----------
		self.OggHigherQuality=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggHigherQualityQualityButton=wxRadioButton(self.OggHigherQuality,wxNewId(),'Quality',wxPoint(1,10),style=wxRB_GROUP)
		self.OggHigherQualityBitrateButton=wxRadioButton(self.OggHigherQuality,wxNewId(),'Bitrate',wxPoint(1,110))
		self.OggHigherQualitySizeButton=wxRadioButton(self.OggHigherQuality,wxNewId(),'Limits',wxPoint(1,210))
		self.OggHigherQualityQualitySliderText=wxStaticText(self.OggHigherQuality,-1,'',wxPoint(138,42))
		self.OggHigherQualityQualitySlider=wxSlider(self.OggHigherQuality,wxNewId(),OggHigherQualityQualitySliderValue,-100, 1000,wxPoint(1,40),wxSize(120,20),wxSL_HORIZONTAL)
		self.OggHigherQualityQualitySliderMoved('')
		self.OggHigherQualityBitrateSlider=wxSlider(self.OggHigherQuality,wxNewId(),OggHigherQualityBitrateSliderValue,48,500,wxPoint(1,140),wxSize(120,20),wxSL_LABELS)
		self.OggHigherQualityText1=wxStaticText(self.OggHigherQuality,-1,'kbps',wxPoint(138,156))
		self.OggHigherQualityText2=wxStaticText(self.OggHigherQuality,-1,'kbps',wxPoint(138,256))
		self.OggHigherQualityText3=wxStaticText(self.OggHigherQuality,-1,'kbps',wxPoint(138,296))
		self.OggHigherQualitySizeMinSlider=wxSlider(self.OggHigherQuality,wxNewId(),OggHigherQualitySizeMinSliderValue,48,500,wxPoint(1,240),wxSize(120,20),wxSL_LABELS)
		self.OggHigherQualitySizeMaxSlider=wxSlider(self.OggHigherQuality,wxNewId(),OggHigherQualitySizeMaxSliderValue,48,500,wxPoint(1,280),wxSize(120,20),wxSL_LABELS)
		EVT_RADIOBUTTON(self.OggHigherQualityQualityButton,self.OggHigherQualityQualityButton.GetId(),self.OggHigherQualityShowQuality)
		EVT_RADIOBUTTON(self.OggHigherQualityBitrateButton,self.OggHigherQualityBitrateButton.GetId(),self.OggHigherQualityShowBitrate)
		EVT_RADIOBUTTON(self.OggHigherQualitySizeButton,self.OggHigherQualitySizeButton.GetId(),self.OggHigherQualityShowSize)
		EVT_SLIDER(self.OggHigherQualityQualitySlider,self.OggHigherQualityQualitySlider.GetId(),self.OggHigherQualityQualitySliderMoved)
		self.OggHigherQualityDisableAll()
		if OggHigherWhichChecked=='quality':
			self.OggHigherQualityShowQuality('')
			self.OggHigherQualityQualityButton.SetValue(1)
			self.OggHigherQualityBitrateButton.SetValue(0)
			self.OggHigherQualitySizeButton.SetValue(0)
		if OggHigherWhichChecked=='bitrate':
			self.OggHigherQualityShowBitrate('')
			self.OggHigherQualityQualityButton.SetValue(0)
			self.OggHigherQualityBitrateButton.SetValue(1)
			self.OggHigherQualitySizeButton.SetValue(0)
		if OggHigherWhichChecked=='size':
			self.OggHigherQualityShowSize('')
			self.OggHigherQualityQualityButton.SetValue(0)
			self.OggHigherQualityBitrateButton.SetValue(0)
			self.OggHigherQualitySizeButton.SetValue(1)
#----------
#----------
		self.OggHighQuality=wxPanel(self.ToOgg,wxNewId(),wxPoint(120,15),wxSize(470,440),wxSUNKEN_BORDER)
		self.OggHighQualityQualityButton=wxRadioButton(self.OggHighQuality,wxNewId(),'Quality',wxPoint(1,10),style=wxRB_GROUP)
		self.OggHighQualityBitrateButton=wxRadioButton(self.OggHighQuality,wxNewId(),'Bitrate',wxPoint(1,110))
		self.OggHighQualitySizeButton=wxRadioButton(self.OggHighQuality,wxNewId(),'Limits',wxPoint(1,210))
		self.OggHighQualityQualitySliderText=wxStaticText(self.OggHighQuality,-1,'',wxPoint(138,42))
		self.OggHighQualityQualitySlider=wxSlider(self.OggHighQuality,wxNewId(),OggHighQualityQualitySliderValue,-100, 1000,wxPoint(1,40),wxSize(120,20),wxSL_HORIZONTAL)
		self.OggHighQualityQualitySliderMoved('')
		self.OggHighQualityBitrateSlider=wxSlider(self.OggHighQuality,wxNewId(),OggHighQualityBitrateSliderValue,48,500,wxPoint(1,140),wxSize(120,20),wxSL_LABELS)
		self.OggHighQualityText1=wxStaticText(self.OggHighQuality,-1,'kbps',wxPoint(138,156))
		self.OggHighQualityText2=wxStaticText(self.OggHighQuality,-1,'kbps',wxPoint(138,256))
		self.OggHighQualityText3=wxStaticText(self.OggHighQuality,-1,'kbps',wxPoint(138,296))
		self.OggHighQualitySizeMinSlider=wxSlider(self.OggHighQuality,wxNewId(),OggHighQualitySizeMinSliderValue,48,500,wxPoint(1,240),wxSize(120,20),wxSL_LABELS)
		self.OggHighQualitySizeMaxSlider=wxSlider(self.OggHighQuality,wxNewId(),OggHighQualitySizeMaxSliderValue,48,500,wxPoint(1,280),wxSize(120,20),wxSL_LABELS)
		EVT_RADIOBUTTON(self.OggHighQualityQualityButton,self.OggHighQualityQualityButton.GetId(),self.OggHighQualityShowQuality)
		EVT_RADIOBUTTON(self.OggHighQualityBitrateButton,self.OggHighQualityBitrateButton.GetId(),self.OggHighQualityShowBitrate)
		EVT_RADIOBUTTON(self.OggHighQualitySizeButton,self.OggHighQualitySizeButton.GetId(),self.OggHighQualityShowSize)
		EVT_SLIDER(self.OggHighQualityQualitySlider,self.OggHighQualityQualitySlider.GetId(),self.OggHighQualityQualitySliderMoved)
		self.OggHighQualityDisableAll()
		if OggHighWhichChecked=='quality':
			self.OggHighQualityShowQuality('')
			self.OggHighQualityQualityButton.SetValue(1)
			self.OggHighQualityBitrateButton.SetValue(0)
			self.OggHighQualitySizeButton.SetValue(0)
		if OggHighWhichChecked=='bitrate':
			self.OggHighQualityShowBitrate('')
			self.OggHighQualityQualityButton.SetValue(0)
			self.OggHighQualityBitrateButton.SetValue(1)
			self.OggHighQualitySizeButton.SetValue(0)
		if OggHighWhichChecked=='size':
			self.OggHighQualityShowSize('')
			self.OggHighQualityQualityButton.SetValue(0)
			self.OggHighQualityBitrateButton.SetValue(0)
			self.OggHighQualitySizeButton.SetValue(1)
#----------

		EVT_RADIOBUTTON(self.OggFromMP3button,self.OggFromMP3button.GetId(),self.ShowOggMP3)
		EVT_RADIOBUTTON(self.OggFromWMAbutton,self.OggFromWMAbutton.GetId(),self.ShowOggWMA)
  		EVT_RADIOBUTTON(self.OggFromOGGbutton,self.OggFromOGGbutton.GetId(),self.ShowOggOGG)
		EVT_RADIOBUTTON(self.OggLowQualitybutton,self.OggLowQualitybutton.GetId(),self.ShowOggLowQuality)
		EVT_RADIOBUTTON(self.OggLowerQualitybutton,self.OggLowerQualitybutton.GetId(),self.ShowOggLowerQuality)
		EVT_RADIOBUTTON(self.OggMediumQualitybutton,self.OggMediumQualitybutton.GetId(),self.ShowOggMediumQuality)
		EVT_RADIOBUTTON(self.OggHigherQualitybutton,self.OggHigherQualitybutton.GetId(),self.ShowOggHigherQuality)
		EVT_RADIOBUTTON(self.OggHighQualitybutton,self.OggHighQualitybutton.GetId(),self.ShowOggHighQuality)
		self.HideAllOgg()
		self.OggFromMP3MainPanel.Show(1)
	def OggLowQualityQualitySliderMoved(self,event):
		self.OggLowQualityQualitySliderText.Destroy()
		self.LowParts=divmod(self.OggLowQualityQualitySlider.GetValue(),100)
		self.SliderTextPartOne=self.LowParts[0]
		self.SliderTextPartTwo=self.LowParts[1]
		if self.SliderTextPartOne == -1:
			if self.SliderTextPartTwo<>0:
				self.SliderTextPartOne="-0"
			self.SliderTextPartTwo=100-self.SliderTextPartTwo
		if self.SliderTextPartTwo==100:
			self.SliderTextPartOne="-1"
			self.SliderTextPartTwo=0
		if not type(self.SliderTextPartOne)=='str':
			self.SliderTextPartOne=str(self.SliderTextPartOne)
		if not type(self.SliderTextPartTwo)=='str':
			self.SliderTextPartTwo=str(self.SliderTextPartTwo)
		self.SliderTextPartTwo=string.zfill(self.SliderTextPartTwo,2)
		self.SliderText=self.SliderTextPartOne+'.'+self.SliderTextPartTwo
		self.OggLowQualityQualitySliderText=wxStaticText(self.OggLowQuality,-1,self.SliderText,wxPoint(138,42))
	def OggLowQualityDisableAll(self):
# It would be better to have all as panel and disable only panel...
		self.OggLowQualitySizeMinSlider.Enable(0)
		self.OggLowQualitySizeMaxSlider.Enable(0)
		self.OggLowQualityBitrateSlider.Enable(0)
		self.OggLowQualityText1.Enable(0)
		self.OggLowQualityText2.Enable(0)
		self.OggLowQualityText3.Enable(0)
		self.OggLowQualityQualitySlider.Enable(0)
		self.OggLowQualityQualitySliderText.Enable(0)
	def OggLowQualityShowQuality(self,junk):
		self.OggLowQualityDisableAll()
		self.OggLowQualityQualitySlider.Enable(1)
		self.OggLowQualityQualitySliderText.Enable(1)
		global OggLowWhichChecked
		OggLowWhichChecked='quality'
	def OggLowQualityShowBitrate(self,junk):
		self.OggLowQualityDisableAll()
		self.OggLowQualityBitrateSlider.Enable(1)
		self.OggLowQualityText1.Enable(1)
		global OggLowWhichChecked
		OggLowWhichChecked='bitrate'
	def OggLowQualityShowSize(self,junk):
		self.OggLowQualityDisableAll()
		self.OggLowQualitySizeMinSlider.Enable(1)
		self.OggLowQualitySizeMaxSlider.Enable(1)
		self.OggLowQualityText2.Enable(1)
		self.OggLowQualityText3.Enable(1)
		global OggLowWhichChecked
		OggLowWhichChecked='size'
#-------
#-------
	def OggLowerQualityQualitySliderMoved(self,event):
		self.OggLowerQualityQualitySliderText.Destroy()
		self.LowerParts=divmod(self.OggLowerQualityQualitySlider.GetValue(),100)
		self.SliderTextPartOne=self.LowerParts[0]
		self.SliderTextPartTwo=self.LowerParts[1]
		if self.SliderTextPartOne == -1:
			if self.SliderTextPartTwo<>0:
				self.SliderTextPartOne="-0"
			self.SliderTextPartTwo=100-self.SliderTextPartTwo
		if self.SliderTextPartTwo==100:
			self.SliderTextPartOne="-1"
			self.SliderTextPartTwo=0
		if not type(self.SliderTextPartOne)=='str':
			self.SliderTextPartOne=str(self.SliderTextPartOne)
		if not type(self.SliderTextPartTwo)=='str':
			self.SliderTextPartTwo=str(self.SliderTextPartTwo)
		self.SliderTextPartTwo=string.zfill(self.SliderTextPartTwo,2)
		self.SliderText=self.SliderTextPartOne+'.'+self.SliderTextPartTwo
		self.OggLowerQualityQualitySliderText=wxStaticText(self.OggLowerQuality,-1,self.SliderText,wxPoint(138,42))
	def OggLowerQualityDisableAll(self):
# It would be better to have all as panel and disable only panel...
		self.OggLowerQualitySizeMinSlider.Enable(0)
		self.OggLowerQualitySizeMaxSlider.Enable(0)
		self.OggLowerQualityBitrateSlider.Enable(0)
		self.OggLowerQualityText1.Enable(0)
		self.OggLowerQualityText2.Enable(0)
		self.OggLowerQualityText3.Enable(0)
		self.OggLowerQualityQualitySlider.Enable(0)
		self.OggLowerQualityQualitySliderText.Enable(0)
	def OggLowerQualityShowQuality(self,junk):
		self.OggLowerQualityDisableAll()
		self.OggLowerQualityQualitySlider.Enable(1)
		self.OggLowerQualityQualitySliderText.Enable(1)
		global OggLowerWhichChecked
		OggLowerWhichChecked='quality'
	def OggLowerQualityShowBitrate(self,junk):
		self.OggLowerQualityDisableAll()
		self.OggLowerQualityBitrateSlider.Enable(1)
		self.OggLowerQualityText1.Enable(1)
		global OggLowerWhichChecked
		OggLowerWhichChecked='bitrate'
	def OggLowerQualityShowSize(self,junk):
		self.OggLowerQualityDisableAll()
		self.OggLowerQualitySizeMinSlider.Enable(1)
		self.OggLowerQualitySizeMaxSlider.Enable(1)
		self.OggLowerQualityText2.Enable(1)
		self.OggLowerQualityText3.Enable(1)
		global OggLowerWhichChecked
		OggLowerWhichChecked='size'
#-------
#-------
	def OggMediumQualityQualitySliderMoved(self,event):
		self.OggMediumQualityQualitySliderText.Destroy()
		self.MediumParts=divmod(self.OggMediumQualityQualitySlider.GetValue(),100)
		self.SliderTextPartOne=self.MediumParts[0]
		self.SliderTextPartTwo=self.MediumParts[1]
		if self.SliderTextPartOne == -1:
			if self.SliderTextPartTwo<>0:
				self.SliderTextPartOne="-0"
			self.SliderTextPartTwo=100-self.SliderTextPartTwo
		if self.SliderTextPartTwo==100:
			self.SliderTextPartOne="-1"
			self.SliderTextPartTwo=0
		if not type(self.SliderTextPartOne)=='str':
			self.SliderTextPartOne=str(self.SliderTextPartOne)
		if not type(self.SliderTextPartTwo)=='str':
			self.SliderTextPartTwo=str(self.SliderTextPartTwo)
		self.SliderTextPartTwo=string.zfill(self.SliderTextPartTwo,2)
		self.SliderText=self.SliderTextPartOne+'.'+self.SliderTextPartTwo
		self.OggMediumQualityQualitySliderText=wxStaticText(self.OggMediumQuality,-1,self.SliderText,wxPoint(138,42))
	def OggMediumQualityDisableAll(self):
# It would be better to have all as panel and disable only panel...
		self.OggMediumQualitySizeMinSlider.Enable(0)
		self.OggMediumQualitySizeMaxSlider.Enable(0)
		self.OggMediumQualityBitrateSlider.Enable(0)
		self.OggMediumQualityText1.Enable(0)
		self.OggMediumQualityText2.Enable(0)
		self.OggMediumQualityText3.Enable(0)
		self.OggMediumQualityQualitySlider.Enable(0)
		self.OggMediumQualityQualitySliderText.Enable(0)
	def OggMediumQualityShowQuality(self,junk):
		self.OggMediumQualityDisableAll()
		self.OggMediumQualityQualitySlider.Enable(1)
		self.OggMediumQualityQualitySliderText.Enable(1)
		global OggMediumWhichChecked
		OggMediumWhichChecked='quality'
	def OggMediumQualityShowBitrate(self,junk):
		self.OggMediumQualityDisableAll()
		self.OggMediumQualityBitrateSlider.Enable(1)
		self.OggMediumQualityText1.Enable(1)
		global OggMediumWhichChecked
		OggMediumWhichChecked='bitrate'
	def OggMediumQualityShowSize(self,junk):
		self.OggMediumQualityDisableAll()
		self.OggMediumQualitySizeMinSlider.Enable(1)
		self.OggMediumQualitySizeMaxSlider.Enable(1)
		self.OggMediumQualityText2.Enable(1)
		self.OggMediumQualityText3.Enable(1)
		global OggMediumWhichChecked
		OggMediumWhichChecked='size'

#-------
#-------
	def OggHigherQualityQualitySliderMoved(self,event):
		self.OggHigherQualityQualitySliderText.Destroy()
		self.HigherParts=divmod(self.OggHigherQualityQualitySlider.GetValue(),100)
		self.SliderTextPartOne=self.HigherParts[0]
		self.SliderTextPartTwo=self.HigherParts[1]
		if self.SliderTextPartOne == -1:
			if self.SliderTextPartTwo<>0:
				self.SliderTextPartOne="-0"
			self.SliderTextPartTwo=100-self.SliderTextPartTwo
		if self.SliderTextPartTwo==100:
			self.SliderTextPartOne="-1"
			self.SliderTextPartTwo=0
		if not type(self.SliderTextPartOne)=='str':
			self.SliderTextPartOne=str(self.SliderTextPartOne)
		if not type(self.SliderTextPartTwo)=='str':
			self.SliderTextPartTwo=str(self.SliderTextPartTwo)
		self.SliderTextPartTwo=string.zfill(self.SliderTextPartTwo,2)
		self.SliderText=self.SliderTextPartOne+'.'+self.SliderTextPartTwo
		self.OggHigherQualityQualitySliderText=wxStaticText(self.OggHigherQuality,-1,self.SliderText,wxPoint(138,42))
	def OggHigherQualityDisableAll(self):
# It would be better to have all as panel and disable only panel...
		self.OggHigherQualitySizeMinSlider.Enable(0)
		self.OggHigherQualitySizeMaxSlider.Enable(0)
		self.OggHigherQualityBitrateSlider.Enable(0)
		self.OggHigherQualityText1.Enable(0)
		self.OggHigherQualityText2.Enable(0)
		self.OggHigherQualityText3.Enable(0)
		self.OggHigherQualityQualitySlider.Enable(0)
		self.OggHigherQualityQualitySliderText.Enable(0)
	def OggHigherQualityShowQuality(self,junk):
		self.OggHigherQualityDisableAll()
		self.OggHigherQualityQualitySlider.Enable(1)
		self.OggHigherQualityQualitySliderText.Enable(1)
		global OggHigherWhichChecked
		OggHigherWhichChecked='quality'
	def OggHigherQualityShowBitrate(self,junk):
		self.OggHigherQualityDisableAll()
		self.OggHigherQualityBitrateSlider.Enable(1)
		self.OggHigherQualityText1.Enable(1)
		global OggHigherWhichChecked
		OggHigherWhichChecked='bitrate'
	def OggHigherQualityShowSize(self,junk):
		self.OggHigherQualityDisableAll()
		self.OggHigherQualitySizeMinSlider.Enable(1)
		self.OggHigherQualitySizeMaxSlider.Enable(1)
		self.OggHigherQualityText2.Enable(1)
		self.OggHigherQualityText3.Enable(1)
		global OggHigherWhichChecked
		OggHigherWhichChecked='size'
#-------
#-------
	def OggHighQualityQualitySliderMoved(self,event):
		self.OggHighQualityQualitySliderText.Destroy()
		self.HighParts=divmod(self.OggHighQualityQualitySlider.GetValue(),100)
		self.SliderTextPartOne=self.HighParts[0]
		self.SliderTextPartTwo=self.HighParts[1]
		if self.SliderTextPartOne == -1:
			if self.SliderTextPartTwo<>0:
				self.SliderTextPartOne="-0"
			self.SliderTextPartTwo=100-self.SliderTextPartTwo
		if self.SliderTextPartTwo==100:
			self.SliderTextPartOne="-1"
			self.SliderTextPartTwo=0
		if not type(self.SliderTextPartOne)=='str':
			self.SliderTextPartOne=str(self.SliderTextPartOne)
		if not type(self.SliderTextPartTwo)=='str':
			self.SliderTextPartTwo=str(self.SliderTextPartTwo)
		self.SliderTextPartTwo=string.zfill(self.SliderTextPartTwo,2)
		self.SliderText=self.SliderTextPartOne+'.'+self.SliderTextPartTwo
		self.OggHighQualityQualitySliderText=wxStaticText(self.OggHighQuality,-1,self.SliderText,wxPoint(138,42))
	def OggHighQualityDisableAll(self):
# It would be better to have all as panel and disable only panel...
		self.OggHighQualitySizeMinSlider.Enable(0)
		self.OggHighQualitySizeMaxSlider.Enable(0)
		self.OggHighQualityBitrateSlider.Enable(0)
		self.OggHighQualityText1.Enable(0)
		self.OggHighQualityText2.Enable(0)
		self.OggHighQualityText3.Enable(0)
		self.OggHighQualityQualitySlider.Enable(0)
		self.OggHighQualityQualitySliderText.Enable(0)
	def OggHighQualityShowQuality(self,junk):
		self.OggHighQualityDisableAll()
		self.OggHighQualityQualitySlider.Enable(1)
		self.OggHighQualityQualitySliderText.Enable(1)
		global OggHighWhichChecked
		OggHighWhichChecked='quality'
	def OggHighQualityShowBitrate(self,junk):
		self.OggHighQualityDisableAll()
		self.OggHighQualityBitrateSlider.Enable(1)
		self.OggHighQualityText1.Enable(1)
		global OggHighWhichChecked
		OggHighWhichChecked='bitrate'
	def OggHighQualityShowSize(self,junk):
		self.OggHighQualityDisableAll()
		self.OggHighQualitySizeMinSlider.Enable(1)
		self.OggHighQualitySizeMaxSlider.Enable(1)
		self.OggHighQualityText2.Enable(1)
		self.OggHighQualityText3.Enable(1)
		global OggHighWhichChecked
		OggHighWhichChecked='size'

#-------
	def HideAllOgg(self):
# It's ugly code, but without hiding all other panels, panel we want to have
# shown might not show. At least it didn't work out on my Gentoo box -
# KDE 3.1.5, wxPython 2.4.1.2
		self.OggFromMP3MainPanel.Show(0)
		self.OggFromWMAMainPanel.Show(0)
		self.OggFromOGGMainPanel.Show(0)
		self.OggLowQuality.Show(0)
		self.OggLowerQuality.Show(0)
		self.OggMediumQuality.Show(0)
		self.OggHigherQuality.Show(0)
		self.OggHighQuality.Show(0)
	def ShowOggMP3(self,junk):
		self.HideAllOgg()
		self.OggFromMP3MainPanel.Show(1)
	def ShowOggWMA(self,junk):
		self.HideAllOgg()
		self.OggFromWMAMainPanel.Show(1)
	def ShowOggOGG(self,junk):
		self.HideAllOgg()
		self.OggFromOGGMainPanel.Show(1)
	def ShowOggLowQuality(self,junk):
		self.HideAllOgg()
		self.OggLowQuality.Show(1)
	def ShowOggLowerQuality(self,junk):
		self.HideAllOgg()
		self.OggLowerQuality.Show(1)
	def ShowOggMediumQuality(self,junk):
		self.HideAllOgg()
		self.OggMediumQuality.Show(1)
	def ShowOggHigherQuality(self,junk):
		self.HideAllOgg()
		self.OggHigherQuality.Show(1)
	def ShowOggHighQuality(self,junk):
		self.HideAllOgg()
		self.OggHighQuality.Show(1)

def SettingsLoadLoader():
	LoadFile=open(ConvertorDataFile,'r')
	global MP3FromMp3LowValue; MP3FromMp3LowValue=pickle.load(LoadFile)
	global MP3FromMp3LowerMinValue; MP3FromMp3LowerMinValue=pickle.load(LoadFile)
	global MP3FromMp3LowerMaxValue; MP3FromMp3LowerMaxValue=pickle.load(LoadFile)
	global MP3FromMp3MediumMinValue; MP3FromMp3MediumMinValue=pickle.load(LoadFile)
	global MP3FromMp3MediumMaxValue; MP3FromMp3MediumMaxValue=pickle.load(LoadFile)
	global MP3FromMp3HigherMinValue; MP3FromMp3HigherMinValue=pickle.load(LoadFile)
	global MP3FromMp3HigherMaxValue; MP3FromMp3HigherMaxValue=pickle.load(LoadFile)
	global MP3FromMp3HighValue; MP3FromMp3HighValue=pickle.load(LoadFile)
	global MP3FromWMALowValue; MP3FromWMALowValue=pickle.load(LoadFile)
	global MP3FromWMALowerMinValue; MP3FromWMALowerMinValue=pickle.load(LoadFile)
	global MP3FromWMALowerMaxValue; MP3FromWMALowerMaxValue=pickle.load(LoadFile)
	global MP3FromWMAMediumMinValue; MP3FromWMAMediumMinValue=pickle.load(LoadFile)
	global MP3FromWMAMediumMaxValue; MP3FromWMAMediumMaxValue=pickle.load(LoadFile)
	global MP3FromWMAHigherMinValue; MP3FromWMAHigherMinValue=pickle.load(LoadFile)
	global MP3FromWMAHigherMaxValue; MP3FromWMAHigherMaxValue=pickle.load(LoadFile)
	global MP3FromWMAHighValue; MP3FromWMAHighValue=pickle.load(LoadFile)
	global MP3FromOGGLowValue; MP3FromOGGLowValue=pickle.load(LoadFile)
	global MP3FromOGGLowerMinValue; MP3FromOGGLowerMinValue=pickle.load(LoadFile)
	global MP3FromOGGLowerMaxValue; MP3FromOGGLowerMaxValue=pickle.load(LoadFile)
	global MP3FromOGGMediumMinValue; MP3FromOGGMediumMinValue=pickle.load(LoadFile)
	global MP3FromOGGMediumMaxValue; MP3FromOGGMediumMaxValue=pickle.load(LoadFile)
	global MP3FromOGGHigherMinValue; MP3FromOGGHigherMinValue=pickle.load(LoadFile)
	global MP3FromOGGHigherMaxValue; MP3FromOGGHigherMaxValue=pickle.load(LoadFile)
	global MP3FromOGGHighValue; MP3FromOGGHighValue=pickle.load(LoadFile)
	global MP3LowQualityBitrateValue; MP3LowQualityBitrateValue=pickle.load(LoadFile)
	global MP3LowQualityBitrateAcoustic; MP3LowQualityBitrateAcoustic=pickle.load(LoadFile)
	global MP3LowQualityQualityTypeValue; MP3LowQualityQualityTypeValue=pickle.load(LoadFile)
	global MP3LowQualityQualityValue; MP3LowQualityQualityValue=pickle.load(LoadFile)
	global MP3LowQualityQualityAcoustic; MP3LowQualityQualityAcoustic=pickle.load(LoadFile)
	global MP3LowQualityQualityMinCheckControlStatus; MP3LowQualityQualityMinCheckControlStatus=pickle.load(LoadFile)
	global MP3LowQualityQualityMinQualityValue; MP3LowQualityQualityMinQualityValue=pickle.load(LoadFile)
	global MP3LowQualityQualityMaxQualityValue; MP3LowQualityQualityMaxQualityValue=pickle.load(LoadFile)
	global MP3LowQualityQualityMaxCheckControlStatus; MP3LowQualityQualityMaxCheckControlStatus=pickle.load(LoadFile)
	global MP3LowQualityQualityEnforceMinStatus; MP3LowQualityQualityEnforceMinStatus=pickle.load(LoadFile)
	global MP3LowQualityABRAcoustic; MP3LowQualityABRAcoustic=pickle.load(LoadFile)
	global MP3LowQualityABRSliderValue; MP3LowQualityABRSliderValue=pickle.load(LoadFile)
	global MP3LowerQualityBitrateValue; MP3LowerQualityBitrateValue=pickle.load(LoadFile)
	global MP3LowerQualityBitrateAcoustic; MP3LowerQualityBitrateAcoustic=pickle.load(LoadFile)
	global MP3LowerQualityQualityTypeValue; MP3LowerQualityQualityTypeValue=pickle.load(LoadFile)
	global MP3LowerQualityQualityValue; MP3LowerQualityQualityValue=pickle.load(LoadFile)
	global MP3LowerQualityQualityAcoustic; MP3LowerQualityQualityAcoustic=pickle.load(LoadFile)
	global MP3LowerQualityQualityMinCheckControlStatus; MP3LowerQualityQualityMinCheckControlStatus=pickle.load(LoadFile)
	global MP3LowerQualityQualityMinQualityValue; MP3LowerQualityQualityMinQualityValue=pickle.load(LoadFile)
	global MP3LowerQualityQualityMaxQualityValue; MP3LowerQualityQualityMaxQualityValue=pickle.load(LoadFile)
	global MP3LowerQualityQualityMaxCheckControlStatus; MP3LowerQualityQualityMaxCheckControlStatus=pickle.load(LoadFile)
	global MP3LowerQualityQualityEnforceMinStatus; MP3LowerQualityQualityEnforceMinStatus=pickle.load(LoadFile)
	global MP3LowerQualityABRAcoustic; MP3LowerQualityABRAcoustic=pickle.load(LoadFile)
	global MP3LowerQualityABRSliderValue; MP3LowerQualityABRSliderValue=pickle.load(LoadFile)
	global MP3MediumQualityBitrateValue; MP3MediumQualityBitrateValue=pickle.load(LoadFile)
	global MP3MediumQualityBitrateAcoustic; MP3MediumQualityBitrateAcoustic=pickle.load(LoadFile)
	global MP3MediumQualityQualityTypeValue; MP3MediumQualityQualityTypeValue=pickle.load(LoadFile)
	global MP3MediumQualityQualityValue; MP3MediumQualityQualityValue=pickle.load(LoadFile)
	global MP3MediumQualityQualityAcoustic; MP3MediumQualityQualityAcoustic=pickle.load(LoadFile)
	global MP3MediumQualityQualityMinCheckControlStatus; MP3MediumQualityQualityMinCheckControlStatus=pickle.load(LoadFile)
	global MP3MediumQualityQualityMinQualityValue; MP3MediumQualityQualityMinQualityValue=pickle.load(LoadFile)
	global MP3MediumQualityQualityMaxQualityValue; MP3MediumQualityQualityMaxQualityValue=pickle.load(LoadFile)
	global MP3MediumQualityQualityMaxCheckControlStatus; MP3MediumQualityQualityMaxCheckControlStatus=pickle.load(LoadFile)
	global MP3MediumQualityQualityEnforceMinStatus; MP3MediumQualityQualityEnforceMinStatus=pickle.load(LoadFile)
	global MP3MediumQualityABRAcoustic; MP3MediumQualityABRAcoustic=pickle.load(LoadFile)
	global MP3MediumQualityABRSliderValue; MP3MediumQualityABRSliderValue=pickle.load(LoadFile)
	global MP3HigherQualityBitrateValue; MP3HigherQualityBitrateValue=pickle.load(LoadFile)
	global MP3HigherQualityBitrateAcoustic; MP3HigherQualityBitrateAcoustic=pickle.load(LoadFile)
	global MP3HigherQualityQualityTypeValue; MP3HigherQualityQualityTypeValue=pickle.load(LoadFile)
	global MP3HigherQualityQualityValue; MP3HigherQualityQualityValue=pickle.load(LoadFile)
	global MP3HigherQualityQualityAcoustic; MP3HigherQualityQualityAcoustic=pickle.load(LoadFile)
	global MP3HigherQualityQualityMinCheckControlStatus; MP3HigherQualityQualityMinCheckControlStatus=pickle.load(LoadFile)
	global MP3HigherQualityQualityMinQualityValue; MP3HigherQualityQualityMinQualityValue=pickle.load(LoadFile)
	global MP3HigherQualityQualityMaxQualityValue; MP3HigherQualityQualityMaxQualityValue=pickle.load(LoadFile)
	global MP3HigherQualityQualityMaxCheckControlStatus; MP3HigherQualityQualityMaxCheckControlStatus=pickle.load(LoadFile)
	global MP3HigherQualityQualityEnforceMinStatus; MP3HigherQualityQualityEnforceMinStatus=pickle.load(LoadFile)
	global MP3HigherQualityABRAcoustic; MP3HigherQualityABRAcoustic=pickle.load(LoadFile)
	global MP3HigherQualityABRSliderValue; MP3HigherQualityABRSliderValue=pickle.load(LoadFile)
	global MP3HighQualityBitrateValue; MP3HighQualityBitrateValue=pickle.load(LoadFile)
	global MP3HighQualityBitrateAcoustic; MP3HighQualityBitrateAcoustic=pickle.load(LoadFile)
	global MP3HighQualityQualityTypeValue; MP3HighQualityQualityTypeValue=pickle.load(LoadFile)
	global MP3HighQualityQualityValue; MP3HighQualityQualityValue=pickle.load(LoadFile)
	global MP3HighQualityQualityAcoustic; MP3HighQualityQualityAcoustic=pickle.load(LoadFile)
	global MP3HighQualityQualityMinCheckControlStatus; MP3HighQualityQualityMinCheckControlStatus=pickle.load(LoadFile)
	global MP3HighQualityQualityMinQualityValue; MP3HighQualityQualityMinQualityValue=pickle.load(LoadFile)
	global MP3HighQualityQualityMaxQualityValue; MP3HighQualityQualityMaxQualityValue=pickle.load(LoadFile)
	global MP3HighQualityQualityMaxCheckControlStatus; MP3HighQualityQualityMaxCheckControlStatus=pickle.load(LoadFile)
	global MP3HighQualityQualityEnforceMinStatus; MP3HighQualityQualityEnforceMinStatus=pickle.load(LoadFile)
	global MP3HighQualityABRAcoustic; MP3HighQualityABRAcoustic=pickle.load(LoadFile)
	global MP3HighQualityABRSliderValue; MP3HighQualityABRSliderValue=pickle.load(LoadFile)
	global MP3LowQualityWhichType; MP3LowQualityWhichType=pickle.load(LoadFile)
	global MP3LowerQualityWhichType; MP3LowerQualityWhichType=pickle.load(LoadFile)
	global MP3MediumQualityWhichType; MP3MediumQualityWhichType=pickle.load(LoadFile)
	global MP3HigherQualityWhichType; MP3HigherQualityWhichType=pickle.load(LoadFile)
	global MP3HighQualityWhichType; MP3HighQualityWhichType=pickle.load(LoadFile)
	global MP3LowQualityQualityModeString; MP3LowQualityQualityModeString=pickle.load(LoadFile)
	global MP3LowQualityBitrateModeString; MP3LowQualityBitrateModeString=pickle.load(LoadFile)
	global MP3LowQualityABRModeString; MP3LowQualityABRModeString=pickle.load(LoadFile)
	global MP3LowerQualityQualityModeString; MP3LowerQualityQualityModeString=pickle.load(LoadFile)
	global MP3LowerQualityBitrateModeString; MP3LowerQualityBitrateModeString=pickle.load(LoadFile)
	global MP3LowerQualityABRModeString; MP3LowerQualityABRModeString=pickle.load(LoadFile)
	global MP3MediumQualityQualityModeString; MP3MediumQualityQualityModeString=pickle.load(LoadFile)
	global MP3MediumQualityBitrateModeString; MP3MediumQualityBitrateModeString=pickle.load(LoadFile)
	global MP3MediumQualityABRModeString; MP3MediumQualityABRModeString=pickle.load(LoadFile)
	global MP3HigherQualityQualityModeString; MP3HigherQualityQualityModeString=pickle.load(LoadFile)
	global MP3HigherQualityBitrateModeString; MP3HigherQualityBitrateModeString=pickle.load(LoadFile)
	global MP3HigherQualityABRModeString; MP3HigherQualityABRModeString=pickle.load(LoadFile)
	global MP3HighQualityQualityModeString; MP3HighQualityQualityModeString=pickle.load(LoadFile)
	global MP3HighQualityBitrateModeString; MP3HighQualityBitrateModeString=pickle.load(LoadFile)
	global MP3HighQualityABRModeString; MP3HighQualityABRModeString=pickle.load(LoadFile)

#----------------
	global OggFromMp3LowValue; OggFromMp3LowValue=pickle.load(LoadFile)
	global OggFromMp3LowerMinValue; OggFromMp3LowerMinValue=pickle.load(LoadFile)
	global OggFromMp3LowerMaxValue; OggFromMp3LowerMaxValue=pickle.load(LoadFile)
	global OggFromMp3MediumMinValue; OggFromMp3MediumMinValue=pickle.load(LoadFile)
	global OggFromMp3MediumMaxValue; OggFromMp3MediumMaxValue=pickle.load(LoadFile)
	global OggFromMp3HigherMinValue; OggFromMp3HigherMinValue=pickle.load(LoadFile)
	global OggFromMp3HigherMaxValue; OggFromMp3HigherMaxValue=pickle.load(LoadFile)
	global OggFromMp3HighValue; OggFromMp3HighValue=pickle.load(LoadFile)
	global OggFromWMALowValue; OggFromWMALowValue=pickle.load(LoadFile)
	global OggFromWMALowerMinValue; OggFromWMALowerMinValue=pickle.load(LoadFile)
	global OggFromWMALowerMaxValue; OggFromWMALowerMaxValue=pickle.load(LoadFile)
	global OggFromWMAMediumMinValue; OggFromWMAMediumMinValue=pickle.load(LoadFile)
	global OggFromWMAMediumMaxValue; OggFromWMAMediumMaxValue=pickle.load(LoadFile)
	global OggFromWMAHigherMinValue; OggFromWMAHigherMinValue=pickle.load(LoadFile)
	global OggFromWMAHigherMaxValue; OggFromWMAHigherMaxValue=pickle.load(LoadFile)
	global OggFromWMAHighValue; OggFromWMAHighValue=pickle.load(LoadFile)
	global OggFromOGGLowValue; OggFromOGGLowValue=pickle.load(LoadFile)
	global OggFromOGGLowerMinValue; OggFromOGGLowerMinValue=pickle.load(LoadFile)
	global OggFromOGGLowerMaxValue; OggFromOGGLowerMaxValue=pickle.load(LoadFile)
	global OggFromOGGMediumMinValue; OggFromOGGMediumMinValue=pickle.load(LoadFile)
	global OggFromOGGMediumMaxValue; OggFromOGGMediumMaxValue=pickle.load(LoadFile)
	global OggFromOGGHigherMinValue; OggFromOGGHigherMinValue=pickle.load(LoadFile)
	global OggFromOGGHigherMaxValue; OggFromOGGHigherMaxValue=pickle.load(LoadFile)
	global OggFromOGGHighValue; OggFromOGGHighValue=pickle.load(LoadFile)
	global OggLowQualityQualitySliderValue; OggLowQualityQualitySliderValue=pickle.load(LoadFile)
	global OggLowQualityBitrateSliderValue; OggLowQualityBitrateSliderValue=pickle.load(LoadFile)
	global OggLowQualitySizeMinSliderValue; OggLowQualitySizeMinSliderValue=pickle.load(LoadFile)
	global OggLowQualitySizeMaxSliderValue; OggLowQualitySizeMaxSliderValue=pickle.load(LoadFile)
	global OggLowerQualityQualitySliderValue; OggLowerQualityQualitySliderValue=pickle.load(LoadFile)
	global OggLowerQualityBitrateSliderValue; OggLowerQualityBitrateSliderValue=pickle.load(LoadFile)
	global OggLowerQualitySizeMinSliderValue; OggLowerQualitySizeMinSliderValue=pickle.load(LoadFile)
	global OggLowerQualitySizeMaxSliderValue; OggLowerQualitySizeMaxSliderValue=pickle.load(LoadFile)
	global OggMediumQualityQualitySliderValue; OggMediumQualityQualitySliderValue=pickle.load(LoadFile)
	global OggMediumQualityBitrateSliderValue; OggMediumQualityBitrateSliderValue=pickle.load(LoadFile)
	global OggMediumQualitySizeMinSliderValue; OggMediumQualitySizeMinSliderValue=pickle.load(LoadFile)
	global OggMediumQualitySizeMaxSliderValue; OggMediumQualitySizeMaxSliderValue=pickle.load(LoadFile)
	global OggHigherQualityQualitySliderValue; OggHigherQualityQualitySliderValue=pickle.load(LoadFile)
	global OggHigherQualityBitrateSliderValue; OggHigherQualityBitrateSliderValue=pickle.load(LoadFile)
	global OggHigherQualitySizeMinSliderValue; OggHigherQualitySizeMinSliderValue=pickle.load(LoadFile)
	global OggHigherQualitySizeMaxSliderValue; OggHigherQualitySizeMaxSliderValue=pickle.load(LoadFile)
	global OggHighQualityQualitySliderValue; OggHighQualityQualitySliderValue=pickle.load(LoadFile)
	global OggHighQualityBitrateSliderValue; OggHighQualityBitrateSliderValue=pickle.load(LoadFile)
	global OggHighQualitySizeMinSliderValue; OggHighQualitySizeMinSliderValue=pickle.load(LoadFile)
	global OggHighQualitySizeMaxSliderValue; OggHighQualitySizeMaxSliderValue=pickle.load(LoadFile)
	global OggLowWhichChecked; OggLowWhichChecked=pickle.load(LoadFile)
	global OggLowerWhichChecked; OggLowerWhichChecked=pickle.load(LoadFile)
	global OggMediumWhichChecked; OggMediumWhichChecked=pickle.load(LoadFile)
	global OggHigherWhichChecked; OggHigherWhichChecked=pickle.load(LoadFile)
	global OggHighWhichChecked; OggHighWhichChecked=pickle.load(LoadFile)
	LoadFile.close()
def SettingsLoad():
	if os.path.exists(ConvertorDataFile):
		try:
			SettingsLoadLoader()
		except:
			SettingsLoadMakeDefault()
	else:
		SettingsLoadMakeDefault()
def SettingsLoadMakeDefault():
	global MP3FromMp3LowValue; MP3FromMp3LowValue=63
	global MP3FromMp3LowerMinValue; MP3FromMp3LowerMinValue=64
	global MP3FromMp3LowerMaxValue; MP3FromMp3LowerMaxValue=127
	global MP3FromMp3MediumMinValue; MP3FromMp3MediumMinValue=128
	global MP3FromMp3MediumMaxValue; MP3FromMp3MediumMaxValue=191
	global MP3FromMp3HigherMinValue; MP3FromMp3HigherMinValue=192
	global MP3FromMp3HigherMaxValue; MP3FromMp3HigherMaxValue=255
	global MP3FromMp3HighValue; MP3FromMp3HighValue=256
	global MP3FromWMALowValue; MP3FromWMALowValue=55
	global MP3FromWMALowerMinValue; MP3FromWMALowerMinValue=56
	global MP3FromWMALowerMaxValue; MP3FromWMALowerMaxValue=95
	global MP3FromWMAMediumMinValue; MP3FromWMAMediumMinValue=96
	global MP3FromWMAMediumMaxValue; MP3FromWMAMediumMaxValue=127
	global MP3FromWMAHigherMinValue; MP3FromWMAHigherMinValue=128
	global MP3FromWMAHigherMaxValue; MP3FromWMAHigherMaxValue=159
	global MP3FromWMAHighValue; MP3FromWMAHighValue=160
	global MP3FromOGGLowValue; MP3FromOGGLowValue=47
	global MP3FromOGGLowerMinValue; MP3FromOGGLowerMinValue=48
	global MP3FromOGGLowerMaxValue; MP3FromOGGLowerMaxValue=63
	global MP3FromOGGMediumMinValue; MP3FromOGGMediumMinValue=64
	global MP3FromOGGMediumMaxValue; MP3FromOGGMediumMaxValue=95
	global MP3FromOGGHigherMinValue; MP3FromOGGHigherMinValue=96
	global MP3FromOGGHigherMaxValue; MP3FromOGGHigherMaxValue=139
	global MP3FromOGGHighValue; MP3FromOGGHighValue=140
	global MP3LowQualityBitrateValue; MP3LowQualityBitrateValue='56'
	global MP3LowQualityBitrateAcoustic; MP3LowQualityBitrateAcoustic=2
	global MP3LowQualityQualityTypeValue; MP3LowQualityQualityTypeValue='new'
	global MP3LowQualityQualityValue; MP3LowQualityQualityValue=9
	global MP3LowQualityQualityAcoustic; MP3LowQualityQualityAcoustic=2
	global MP3LowQualityQualityMinCheckControlStatus; MP3LowQualityQualityMinCheckControlStatus=0
	global MP3LowQualityQualityMinQualityValue; MP3LowQualityQualityMinQualityValue='32'
	global MP3LowQualityQualityMaxQualityValue; MP3LowQualityQualityMaxQualityValue='64'
	global MP3LowQualityQualityMaxCheckControlStatus; MP3LowQualityQualityMaxCheckControlStatus=1
	global MP3LowQualityQualityEnforceMinStatus; MP3LowQualityQualityEnforceMinStatus=0
	global MP3LowQualityABRAcoustic; MP3LowQualityABRAcoustic=2
	global MP3LowQualityABRSliderValue; MP3LowQualityABRSliderValue=56
	global MP3LowerQualityBitrateValue; MP3LowerQualityBitrateValue='112'
	global MP3LowerQualityBitrateAcoustic; MP3LowerQualityBitrateAcoustic=2
	global MP3LowerQualityQualityTypeValue; MP3LowerQualityQualityTypeValue='new'
	global MP3LowerQualityQualityValue; MP3LowerQualityQualityValue=8
	global MP3LowerQualityQualityAcoustic; MP3LowerQualityQualityAcoustic=2
	global MP3LowerQualityQualityMinCheckControlStatus; MP3LowerQualityQualityMinCheckControlStatus=0
	global MP3LowerQualityQualityMinQualityValue; MP3LowerQualityQualityMinQualityValue='32'
	global MP3LowerQualityQualityMaxQualityValue; MP3LowerQualityQualityMaxQualityValue='320'
	global MP3LowerQualityQualityMaxCheckControlStatus; MP3LowerQualityQualityMaxCheckControlStatus=0
	global MP3LowerQualityQualityEnforceMinStatus; MP3LowerQualityQualityEnforceMinStatus=0
	global MP3LowerQualityABRAcoustic; MP3LowerQualityABRAcoustic=2
	global MP3LowerQualityABRSliderValue; MP3LowerQualityABRSliderValue=100
	global MP3MediumQualityBitrateValue; MP3MediumQualityBitrateValue='160'
	global MP3MediumQualityBitrateAcoustic; MP3MediumQualityBitrateAcoustic=2
	global MP3MediumQualityQualityTypeValue; MP3MediumQualityQualityTypeValue='new'
	global MP3MediumQualityQualityValue; MP3MediumQualityQualityValue=3
	global MP3MediumQualityQualityAcoustic; MP3MediumQualityQualityAcoustic=2
	global MP3MediumQualityQualityMinCheckControlStatus; MP3MediumQualityQualityMinCheckControlStatus=0
	global MP3MediumQualityQualityMinQualityValue; MP3MediumQualityQualityMinQualityValue='32'
	global MP3MediumQualityQualityMaxQualityValue; MP3MediumQualityQualityMaxQualityValue='320'
	global MP3MediumQualityQualityMaxCheckControlStatus; MP3MediumQualityQualityMaxCheckControlStatus=0
	global MP3MediumQualityQualityEnforceMinStatus; MP3MediumQualityQualityEnforceMinStatus=0
	global MP3MediumQualityABRAcoustic; MP3MediumQualityABRAcoustic=2
	global MP3MediumQualityABRSliderValue; MP3MediumQualityABRSliderValue=140
	global MP3HigherQualityBitrateValue; MP3HigherQualityBitrateValue='256'
	global MP3HigherQualityBitrateAcoustic; MP3HigherQualityBitrateAcoustic=0
	global MP3HigherQualityQualityTypeValue; MP3HigherQualityQualityTypeValue='new'
	global MP3HigherQualityQualityValue; MP3HigherQualityQualityValue=0
	global MP3HigherQualityQualityAcoustic; MP3HigherQualityQualityAcoustic=0
	global MP3HigherQualityQualityMinCheckControlStatus; MP3HigherQualityQualityMinCheckControlStatus=1
	global MP3HigherQualityQualityMinQualityValue; MP3HigherQualityQualityMinQualityValue='160'
	global MP3HigherQualityQualityMaxQualityValue; MP3HigherQualityQualityMaxQualityValue='320'
	global MP3HigherQualityQualityMaxCheckControlStatus; MP3HigherQualityQualityMaxCheckControlStatus=0
	global MP3HigherQualityQualityEnforceMinStatus; MP3HigherQualityQualityEnforceMinStatus=0
	global MP3HigherQualityABRAcoustic; MP3HigherQualityABRAcoustic=0
	global MP3HigherQualityABRSliderValue; MP3HigherQualityABRSliderValue=210
	global MP3HighQualityBitrateValue; MP3HighQualityBitrateValue='320'
	global MP3HighQualityBitrateAcoustic; MP3HighQualityBitrateAcoustic=0
	global MP3HighQualityQualityTypeValue; MP3HighQualityQualityTypeValue='new'
	global MP3HighQualityQualityValue; MP3HighQualityQualityValue=0
	global MP3HighQualityQualityAcoustic; MP3HighQualityQualityAcoustic=0
	global MP3HighQualityQualityMinCheckControlStatus; MP3HighQualityQualityMinCheckControlStatus=1
	global MP3HighQualityQualityMinQualityValue; MP3HighQualityQualityMinQualityValue='224'
	global MP3HighQualityQualityMaxQualityValue; MP3HighQualityQualityMaxQualityValue='320'
	global MP3HighQualityQualityMaxCheckControlStatus; MP3HighQualityQualityMaxCheckControlStatus=0
	global MP3HighQualityQualityEnforceMinStatus; MP3HighQualityQualityEnforceMinStatus=0
	global MP3HighQualityABRAcoustic; MP3HighQualityABRAcoustic=0
	global MP3HighQualityABRSliderValue; MP3HighQualityABRSliderValue=270
	global MP3LowQualityWhichType; MP3LowQualityWhichType='ABR'
	global MP3LowerQualityWhichType; MP3LowerQualityWhichType='VBR'
	global MP3MediumQualityWhichType; MP3MediumQualityWhichType='VBR'
	global MP3HigherQualityWhichType; MP3HigherQualityWhichType='VBR'
	global MP3HighQualityWhichType; MP3HighQualityWhichType='ABR'
	global MP3LowQualityQualityModeString; MP3LowQualityQualityModeString='Joint-Stereo'
	global MP3LowQualityBitrateModeString; MP3LowQualityBitrateModeString='Joint-Stereo'
	global MP3LowQualityABRModeString; MP3LowQualityABRModeString='Joint-Stereo'
	global MP3LowerQualityQualityModeString; MP3LowerQualityQualityModeString='Joint-Stereo'
	global MP3LowerQualityBitrateModeString; MP3LowerQualityBitrateModeString='Joint-Stereo'
	global MP3LowerQualityABRModeString; MP3LowerQualityABRModeString='Joint-Stereo'
	global MP3MediumQualityQualityModeString; MP3MediumQualityQualityModeString='Joint-Stereo'
	global MP3MediumQualityBitrateModeString; MP3MediumQualityBitrateModeString='Joint-Stereo'
	global MP3MediumQualityABRModeString; MP3MediumQualityABRModeString='Joint-Stereo'
	global MP3HigherQualityQualityModeString; MP3HigherQualityQualityModeString='Joint-Stereo'
	global MP3HigherQualityBitrateModeString; MP3HigherQualityBitrateModeString='Joint-Stereo'
	global MP3HigherQualityABRModeString; MP3HigherQualityABRModeString='Joint-Stereo'
	global MP3HighQualityQualityModeString; MP3HighQualityQualityModeString='Joint-Stereo'
	global MP3HighQualityBitrateModeString; MP3HighQualityBitrateModeString='Joint-Stereo'
	global MP3HighQualityABRModeString; MP3HighQualityABRModeString='Joint-Stereo'

	#----------------
	global OggFromMp3LowValue; OggFromMp3LowValue=63
	global OggFromMp3LowerMinValue; OggFromMp3LowerMinValue=64
	global OggFromMp3LowerMaxValue; OggFromMp3LowerMaxValue=127
	global OggFromMp3MediumMinValue; OggFromMp3MediumMinValue=128
	global OggFromMp3MediumMaxValue; OggFromMp3MediumMaxValue=191
	global OggFromMp3HigherMinValue; OggFromMp3HigherMinValue=192
	global OggFromMp3HigherMaxValue; OggFromMp3HigherMaxValue=255
	global OggFromMp3HighValue; OggFromMp3HighValue=256
	global OggFromWMALowValue; OggFromWMALowValue=55
	global OggFromWMALowerMinValue; OggFromWMALowerMinValue=56
	global OggFromWMALowerMaxValue; OggFromWMALowerMaxValue=95
	global OggFromWMAMediumMinValue; OggFromWMAMediumMinValue=96
	global OggFromWMAMediumMaxValue; OggFromWMAMediumMaxValue=127
	global OggFromWMAHigherMinValue; OggFromWMAHigherMinValue=128
	global OggFromWMAHigherMaxValue; OggFromWMAHigherMaxValue=159
	global OggFromWMAHighValue; OggFromWMAHighValue=160
	global OggFromOGGLowValue; OggFromOGGLowValue=47
	global OggFromOGGLowerMinValue; OggFromOGGLowerMinValue=48
	global OggFromOGGLowerMaxValue; OggFromOGGLowerMaxValue=63
	global OggFromOGGMediumMinValue; OggFromOGGMediumMinValue=64
	global OggFromOGGMediumMaxValue; OggFromOGGMediumMaxValue=95
	global OggFromOGGHigherMinValue; OggFromOGGHigherMinValue=96
	global OggFromOGGHigherMaxValue; OggFromOGGHigherMaxValue=139
	global OggFromOGGHighValue; OggFromOGGHighValue=140
	global OggLowQualityQualitySliderValue; OggLowQualityQualitySliderValue=-100
	global OggLowQualityBitrateSliderValue; OggLowQualityBitrateSliderValue=48
	global OggLowQualitySizeMinSliderValue; OggLowQualitySizeMinSliderValue=48
	global OggLowQualitySizeMaxSliderValue; OggLowQualitySizeMaxSliderValue=52
	global OggLowerQualityQualitySliderValue; OggLowerQualityQualitySliderValue=-25
	global OggLowerQualityBitrateSliderValue; OggLowerQualityBitrateSliderValue=56
	global OggLowerQualitySizeMinSliderValue; OggLowerQualitySizeMinSliderValue=50
	global OggLowerQualitySizeMaxSliderValue; OggLowerQualitySizeMaxSliderValue=62
	global OggMediumQualityQualitySliderValue; OggMediumQualityQualitySliderValue=125
	global OggMediumQualityBitrateSliderValue; OggMediumQualityBitrateSliderValue=80
	global OggMediumQualitySizeMinSliderValue; OggMediumQualitySizeMinSliderValue=74
	global OggMediumQualitySizeMaxSliderValue; OggMediumQualitySizeMaxSliderValue=86
	global OggHigherQualityQualitySliderValue; OggHigherQualityQualitySliderValue=450
	global OggHigherQualityBitrateSliderValue; OggHigherQualityBitrateSliderValue=120
	global OggHigherQualitySizeMinSliderValue; OggHigherQualitySizeMinSliderValue=114
	global OggHigherQualitySizeMaxSliderValue; OggHigherQualitySizeMaxSliderValue=126
	global OggHighQualityQualitySliderValue; OggHighQualityQualitySliderValue=600
	global OggHighQualityBitrateSliderValue; OggHighQualityBitrateSliderValue=160
	global OggHighQualitySizeMinSliderValue; OggHighQualitySizeMinSliderValue=154
	global OggHighQualitySizeMaxSliderValue; OggHighQualitySizeMaxSliderValue=166
	global OggLowWhichChecked; OggLowWhichChecked='quality'
	global OggLowerWhichChecked; OggLowerWhichChecked='quality'
	global OggMediumWhichChecked; OggMediumWhichChecked='quality'
	global OggHigherWhichChecked; OggHigherWhichChecked='quality'
	global OggHighWhichChecked; OggHighWhichChecked='quality'
